#define JLv1_1
#undef PNv1

#if defined JLv1_1
/* Version 1.1 produced 24 Aug 90. Mends bug when nomatchcount just makes
   ten then comes down again to 9.  Bug shows itself as a division by zero.
   Version 1.1 has also been improved so that a small negative pointer does
   not produce no match problems. */
#endif

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <malloc.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <time.h>
#if defined _MSC_VER
# include <sys/utime.h>
#else
# include <utime.h>
#endif

#if !defined MSDOS
# if defined __BORLANDC__ || defined __HIGHC__
#  define MSDOS
# endif
#endif

#if defined MSDOS || defined _WINDOWS
# include <io.h>
# include <conio.h>
# define refresh()
# define CREATEFLAGS (S_IREAD|S_IWRITE)
# define PATH_DELIMITER "\\"
# if _MSC_VER>=700 && _MSC_VER<=800
#  define TIMECORR1 ((unsigned long) 25568L*24L*60L*60L)
# endif
#else
# if !defined JUNIOR
#  include <curses.h>
# endif
# define O_BINARY 0
# define CREATEFLAGS (S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH|S_IWOTH)
# define PATH_DELIMITER "/"
#endif

#if !defined JUNIOR
# include "dirvid.h"
# include "print.h"
#endif
#if defined LONGNAME
# include "longname.h"
#endif
#if defined FORTIFY
# include "fortify.h"
#endif

#define IBUF 100
/* IBUF is the input buffer size for obtaining the ascii value of each
   byte.  Speed seems relatively independent of the IBUF size. */

#define OBUF 1024

#define ISIZE  32000
#define ISIZE1 22000
#define ISIZE2 (ISIZE-ISIZE1)
#define ISIZE3 (ISIZE1-ISIZE2)
/* This is the hunk of file that we work with.   We read in the first
   32000 (or all if less),  and then try to obtain matches for the first
   22000 of new.   Then we go again,   throwing away the
   first 10000 (ISIZE2),  and reading in the next 10000,  then matching
   from 12000 (ISIZE3) up to 22000, and so on. */

#define ISEG 16
/* This is the hunk we use for basic matching.
   ISEG*256 must be less than 32K-1,  because we sum ISEG values into
   an INTEGER value. */

#define MAXINSERT 1000
/* This is the area of the search for matches from the current position.
   Speed is directly proportional to the size of this. */

#define SEGARRAYSIZE  ((int) (ISIZE/ISEG))
#define SEGARRAYSIZE1 ((int) (ISIZE1/ISEG))
/* This is the size of the arrays holding details of matches */

#if defined JLv1_1
# define Nchecked 100
#else
# define Nchecked 10
#endif

#if !defined FALSE
# define FALSE 0
#endif

#if !defined TRUE
# define TRUE 1
#endif

#ifndef S_IRUSR
# define S_IRUSR 0400            /* read permission: user */
#endif
#ifndef S_IWUSR
# define S_IWUSR 0200            /* write permission: user */
#endif
#ifndef S_IRGRP
# define S_IRGRP 00040		 /* read permission: group */
#endif
#ifndef S_IWGRP
# define S_IWGRP 00020		 /* write permission: group */
#endif
#ifndef S_IROTH
# define S_IROTH 00004		 /* read permission: other */
#endif
#ifndef S_IWOTH
# define S_IWOTH 00002		 /* write permission: other */
#endif
#ifndef S_IXUSR
# define S_IXUSR 00100           /* execute permission: user */
#endif
#ifndef S_IXGRP
# define S_IXGRP 00010           /* execute permission: group */
#endif
#ifndef S_IXOTH
# define S_IXOTH 00001           /* execute permission: other */
#endif

unsigned char *bytesold;
/* This is the array of bytes from the old version */

unsigned char *bytesnew;
/* This is the array of bytes from the new version */

int *matched;
/* This is the array that says where we have a match (0 if none)
   for each block of ISEG bytes. */

int *pointerchange;
/* This array holds the change in the offset pointer needed for this match. */

char *matchtype;
/* This holds the type of the match,  1 for type A,  2 for type B,  and
   3 for type C. */

char *subtype;
/* For type B and C matches,  this identifies the diffs to use. */

int *differa;
int *differb;
int *differc;
int *differd;
/* These hold the diffa and the diffb values for type B and type C
   matches.  The value is new - old.  Differc and differd are used
   for type D matches.  Note that for type D,  one differ may be zero. */

unsigned char bitval[8+1];
/* holds the values of the bits in an octet for easy setting in bitmaps */

int gdiff[4+1],gdiffcnt[4+1];
/* Used to hold the global difference values we maintain during analysis */

int gdiff2[4+1];
/* Used to hold the global difference values we maintain during output */

char *obuff,bitstring[8*16*3+7+1],diff3str[3+1],
     newfile[128],reffile[128],sendfile[128],
     *version="JLPAK Copyright IT Institute/P. Notebaert - Forward compression program V2.0",
     perc[6],prevperc[6];

#if defined JUNIOR
# define BriefMsg 1
#else
  char BriefMsg,ProgMsg,InvMsg,Trace2file,diagoutput[128];
#endif

unsigned char *buff;

int i,valjl,checked,n,k,
    fp,fpold,fpnew,newblocks,hunkstart,endold,endnew,
    factor,skipval,nomatchcnt,resyncstate,nomatches,ptrchs,
    lastfullmatch,cumptr,octval,n0,ICNT1,ICNT2,Move,startoffset,offset,
    nnn,j,newstart,ik,ii,ptr2,ptrcase,oldstart,testdiff,dcase,bitmap,
    diff1,diff2,diff3,diff4,blen,outc,jj,finished,extras,newoffsetsummcheck=-1,
    oldoffsetsummcheck=-1;
#if !defined JUNIOR
 int cursesdefined;
#endif

#if defined SUMCHK
 int oldsumcheck1,oldsumcheck2,sumcheck1,sumcheck2;
#else
 unsigned long oldcrc,newcrc;
 unsigned short mode;
#endif
long done,usedold,donesegs,lengthold,lengthnew,lastperc,investigate,outputcnt,
     outjl,ptr,typeacnt,typebcnt,typeccnt,typed1cnt,typed2cnt,c1,c2,k1;
double realperc;
FILE *dgf;
struct stat statbuf;

extern unsigned long updcrc();

void EndOfPgr(i)
 int i;
 {
  if (fp>=0) {
   if (n) write(fp,obuff,n);
   if (newoffsetsummcheck>=0) {
#   if defined SUMCHK
     sprintf(obuff,"%c%c",sumcheck1,sumcheck2);
     n=2;
#   else
     newcrc=updcrc((unsigned char *) obuff,0,&newcrc);
     sprintf(obuff,"%c%c%c%c",
             (char) (newcrc&0xff),(char) ((newcrc>>8)&0xff),
             (char) ((newcrc>>16)&0xff),(char) ((newcrc>>24)&0xff));
     n=4;
#   endif
    lseek(fp,(long) newoffsetsummcheck,SEEK_SET);
    write(fp,obuff,n);
   }
   if (oldoffsetsummcheck>=0) {
#   if defined SUMCHK
#   else
     oldcrc=updcrc((unsigned char *) obuff,0,&oldcrc);
     sprintf(obuff,"%c%c%c%c",
             (char) (oldcrc&0xff),(char) ((oldcrc>>8)&0xff),
             (char) ((oldcrc>>16)&0xff),(char) ((oldcrc>>24)&0xff));
     n=4;
     lseek(fp,(long) oldoffsetsummcheck,SEEK_SET);
     write(fp,obuff,n);
#   endif
   }
   n=0;
   close(fp);
  }
  if (dgf!=NULL) fclose(dgf);
  if (fpnew>=0) close(fpnew);
  if (fpold>=0) close(fpold);
  if (i) unlink(sendfile);
# if !defined JUNIOR
   if (cursesdefined) {
    cursor_on();
#   if !defined MSDOS && !defined _WINDOWS
     refresh();
     endwin();
#   endif
   }
# endif
  exit(i);
 }

void *MALLOC(size)
 size_t size;
 {
  void *pointer;

  if ((pointer=(void *) malloc(size))==NULL) {
   fprintf(stderr,"\n\rmalloc(): out of memory\n\r");
   EndOfPgr(1);
  }
  return(pointer);
 }

void *REALLOC(oldptr,size)
 void *oldptr;
 size_t size;
 {
  void *pointer;

  if (oldptr==NULL) pointer=MALLOC(size);
  else if ((pointer=(void *) realloc(oldptr,size))==NULL) {
   fprintf(stderr,"\n\rrealloc(): out of memory\n\r");
   EndOfPgr(1);
  }
  return(pointer);
 }

#if !defined JUNIOR
static void initcurses()
 {
# if !defined MSDOS && !defined _WINDOWS
   if (!cursesdefined) {
    if (initscr()==NULL) {
     int handle;
     char buf[1];

     fprintf(stderr,"\n\rUnable to work with curses\n\r");
#    if defined M_TERMCAP
      if ((handle=open("/etc/termcap",O_RDONLY))<0)
       fprintf(stderr," Can not access /etc/termcap (rights ?) !\n\r");
      else if (read(handle,buf,1)!=1)
       fprintf(stderr," Can not read in /etc/termcap (rights ?) !\n\r");
      else close(handle);
#    endif
     EndOfPgr(1);
    }
   }
   scrollok(stdscr,TRUE);
   cbreak();
   noecho();
   nonl();
# endif
  cursesdefined=TRUE;
 }
#endif

/*
 This is part of the eventual documentation,  and describes the
 compressed format based on this approach.

 There will be an initial block

 Decompression will be abandonned if the reference file is not found
 on the receiving system,  with the correct sumcheck,  and TEMP.TMP will
 not be copied unless the sum - checks of the original file match with the
 decompressed one.

 The receivers state is set up with ptroffset=0, gdiff2(1)=0, gdiff2(2)=0,
 gdiff2(3)=0,  gdiff2(4)=0.   These values are retained unless explicitly
 changed.  The target value is old plus difference. (Difference is new - old).
 The old values to be used are at cnt+ptroffset+1 to
 cnt+ptroffset+ISEG,  where cnt is the number
 of new octets generated so far.  A positive pointer change is an addition
 to ptroffset.
 (A ptroffset is old posn - new posn for compression).

 The following algorithm determines the compressed format:

 We take each ISEG block in turn.

 If there is no match, we output 10nnnnnn followed by the nnnnnn sets of
 16 octets for up to 64 (nnnnnn of 0 means 64) segments.
 Note that 11nnnnnn is used for total matches (see below).  All other
 codes are 0xxxxxxx.
 On decompression,  we branch on bit 1 equals 1 or 0,  and if bit 1 is
 1,  then we branch on 10 or 11.  For 10,  we pick up nnnnnn,  and copy
 ISEG*nnnnnn octetcs from the fcm to the target.

 If there is a pointer change,  we need to signal it in the output.
 We have four cases for the value of the ptr change:
              positive and less than (or equals) 256
              negative and less than (or equals) 256
              positive and over 256
              negative and over 256
 We use 00000000,  00000001, 00010000, and 00010001 for these four cases.
 In the first two cases,  we follow with a single octet,  and in the last
 two with two octets.  In the case of the single octet,  zero means 256.
 On decompression,  we are in the first bit zero case,  and branch first on
 the bottom four bits,  taking the 0 and 1 cases here.  For zero,  we are
 collecting a positive value, and for 1 a negative.  Next we branch on the
 value of nnn in 0nnn000x.  For 0 we have a single octet following and
 a value to be added (after negation if necessary) to ptroffset.  For 1
 we have a two octet value (most significant first).

 Next we look at whether a diffa, diffb, diffc,  diffd change is needed.
 If a change of a diff is needed,  we
 have the following cases for the diff:
	      positive and less than 256
              negative and less than 256
 We use 00100000 and 00100001 for these cases for diffa,  00110000 and
 00110001 for these cases for diffb,  01000000 and 01000001 for diffc,
 and 0101000 and 01010001 for diffd,  followed by a single byte which gives
 the fcm diff value.
 On decompression, this is the nnn=2 (diffa), 3 (diffb), 4 (diffc) and
 5 (diffd) cases described under pointer above.

 This completes the use of the 0mmm0000 and 0mmm0001 values
 except for 110 which is used in termination below,  and 111 which is spare.
 Remaining codes are
 0mmmxxxx where xxxx is above 0001.

 In all cases,  apart from no match,  we first code any pointer change
 needed,  then any one or more diff changes that are needed,  then we code
 the type.

 For a type A match,  we look
 to see if the next block is also type A with no pointer change.  If so,
 we count the number of blocks we can merge in,  up to a maximum of 64,
 and output 11nnnnnn,  where n is the count of the number of merged - in
 blocks
 (nnnnnn all zeros means 64).
 On decompression,  this is the branch from first bit 1,  first two 11.
 We copy ISEG*nnnnnn octets from the old file,  starting at cnt +
 ptroffset+1.

 For a type B match,  we determine whether to use diffa,  b, c,  or d (based
 on this segment alone,  and possibly with a diff change).  We then merge in
 up to 8 segments (nnn=000 means 8) with the same pointer and diff value
 (after juggling diffs if necessary).  The coding is 0nnn0010 for use of diffa
 0nnn0011 for use of diffb,  0nnn0100 for use of diffc,  and 0nnn0101 for use of
 diffd.  nnn is the number of segments merged in.  We then follow with a
 string of bits,  one per byte in each of the segments,  where 0 means no
 addition, and 1 means add in the selected diff.   Bits up to the next octet
 boundary are ignored.
 On decompression,  we use nnn to determine the number of octets to be
 produced (16*nnn),  and then take as many octets as necessary to give
 us the additions of diffa,  b etc.  We start the old at cnt+ptroffset+1
 and we set new to old+diff. (Diff was defined as new - old)

 For a type C match,  we have six possible diff selections to use, coded as
 follows (again,  merging in up to 8 possible segments):
            diffa and diffb    0nnn0110
            diffa and diffc    0nnn0111
	    diffa and diffd    0nnn1000
            diffb and diffc    0nnn1001
            diffb and diffd    0nnn1010
            diffc and diffd    0nnn1011

 We then follow with a string of bits,  one per byte in each of the segments,
 where 0 means no addition,  and 10 means the first mentioned diff is added in,
 and 11 means the second mentionned diff is added in.
 On decompression,  this is values 6 to 11 of the bottom four octets. We
 proceed as for case B, except that we need to use two diffs,  diff1 and diff2
 taken from diffa to diffd according to the case being considered.

 For a type D match,  we encode the segments
 as 0nnn1100 (for up to 8 segments) where we have four differs,  and
 0nnn1101 where diffa is omitted, 0nnn1110 where diffb is omitted,  0nnn1111
 where diffc is omitted.  For diffd omitted,  we have no code space left,
 and treat that as if it were a four differ (code 0nnn1100).
 This is followed by a bitstring for each
 octet in each of the segments,  where we have 0 if no diff is to
 be added in,  then,  for the three differs in use,
 100 if the first is to be added in, 101 for the second,  and 11 for the third.
 For four differs,  we have
 100 if diffa is to be added in,  101 for diffb,  110 for diffc,
 111 for diffd.
 On decompression,  this is again similar to CASE C,  except that we have
 three or four differs depending on the value 12 (four) or 13 to 16 (three)
 of the case.  The value of the case says which differ is omitted.

 Finally,  we have to cope with the residual set of up to 15 octets at the
 end of the file.   We simply output 00001110,  then a single octet saying
 how many follow,  then the octets.  If there are none,  we still output
 the single octet and the null count.  On decompression,  we copy octets
 across.

 Where we have discarded some old file and refilled the buffers,  we
 signal this
 in the output by putting out a single octet of 00011110 followed by
 two octets giving the amount of the move.
 On decompression,  this is a signal to move the new file by the full
 12K,  and to move the old file by the specified amount.

 This ends the use of the 0nnnxxxx codes.  The value 1111 of xxxx is
 spare.

 Thus,  we get the following counts:
     first no match                  17
     subsequent no match (up to 128) 16
     ptr change (<256)                2
     ptr change (>256)                3
     diff change                      2
     type A                           1 (?+3-ptr change)
     subsequent A (up to 128)         0
     type B                           3 (?+5-ptr+1 diff)
     subsequent B (up to 8)           2
     type C                           4 to 5 bytes (?+7-ptr+2 diff)
     subsequent C (up to 8)           2 to 4 bytes
     type D or E                      4 to 7 bytes (?+5/4-ptr/diff+ diff)
 NOTE - We recognise D or E only if there is at most 1 ptr and one diff,  or
 two diff changes.
*/

int fchangesok (x, ip, diff1, diff2, diff3, diff4)
 int x, ip, diff1, diff2, diff3, diff4;
 {
  int diff[4+1], gotit[4+1],m,matchcnt,nok,ok,changesok,mincnt,notneeded,i,j,k;

  diff[1]=diff1;
  diff[2]=diff2;
  diff[3]=diff3;
  diff[4]=diff4;
  m=4;
  subtype[ip]=0;
  if (diff4==0) m=3;
  matchcnt=0;
  for (j=1;j<=m;j++) {
   gotit[j]=0;
   for (i=1;i<=4;i++)
    if (diff[j]==gdiff[i]) {
     gotit[j]=i;
     matchcnt=matchcnt+1;
    }
  }

  for (i=1;i<=4;i++)
   if (gdiffcnt[i]==0) matchcnt=matchcnt+1;

  nok=0;
  ok=1;

  changesok=ok;
  if ((x-ip*ISEG!=ptr) && (matchcnt<m-2) && (resyncstate==0)) changesok=nok;
/* If we have a pointer move,  we require no more than two new diffs unless
   we are resynching,  when anything goes. */

  if (changesok==1) {
   for (j=1;j<=m;j++) {
    k=gotit[j];
    if (k!=0) gdiffcnt[k]=gdiffcnt[k]+32;
   }
   for (j=1;j<=m;j++)
    if (gotit[j]==0) {
     mincnt=1;
     for (i=1;i<=4;i++)
      if (gdiffcnt[i]<gdiffcnt[mincnt]) mincnt=i;
     gdiffcnt[mincnt]=gdiffcnt[mincnt]+32;
     gdiff[mincnt]=diff[j];
    }
  }

  if (m!=4)
   for (i=1;i<=4;i++) {
    notneeded=1;
    for (j=1;j<=m;j++)
     if (gdiff[i]==diff[j]) notneeded=0;
    if (notneeded==1) subtype[ip]=i;
   }
  return(changesok);
 }

char *basename(file)
 char *file;
 {
  char *pointer,*pointer1;

  pointer=strrchr(file,'.');
  pointer1=strrchr(file,*PATH_DELIMITER);
  if ((pointer!=NULL) && ((pointer1==NULL) || (pointer-pointer1>0))) *pointer='\0';
  if (pointer1!=NULL) pointer1++;
  else pointer1=file;
  return(pointer1);
 }

int usage(argv)
 char **argv;
 {
  printf("\r%s\n\r\n",version);
  printf("Usage: %s new-file old-file diff-file%s\n\r",
	 basename(argv[0]),
#if defined JUNIOR
         ""
#else
         " [B|P][I][T trace-file]"
#endif
        );
  printf( "         new-file: file to be compressed (ie newest version)\n\r");
  printf( "         old-file: reference file (ie old version)\n\r");
  printf( "        diff-file: file that holds the differences\n\r");
# if !defined JUNIOR
   printf("           B or P: optional verbose level; P=progress, B=brief (default)\n\r");
   printf("                I: optional investigation\n\r");
   printf("     T trace-file: optional trace file\n\r");
# endif
  printf( " or\n\r");
  printf( "       %s @ctlfile\n\r",basename(argv[0]));
  printf( "           with ctlfile a controlfile which contains the arguments as described\n\r");
  printf( "           above.\n\r");
  EndOfPgr(1);
  return(0);
 }

int GetCommNames(argc,argv)
 int argc;
 char **argv;
 {
  char **z,*ptr;
  int numargs;

  z=argv;
  numargs=argc-1;

  if ((argc==2) && (argv[1][0]=='@')) {
   FILE *fp;
   char str[1024],*ptr1,c;
   int i;

   if ((fp=fopen(argv[1]+1,"r"))==NULL) {
    fprintf(stderr,"Unable to open control file %s\n",argv[1]+1);
    EndOfPgr(1);
   }
   numargs=0;
   z=NULL;
   while (fgets(str,sizeof(str),fp)!=NULL) {
    if ((ptr=strchr(str,'\n'))!=NULL) *ptr=0;
    ptr=str;
    do {
     while (isspace(*ptr)) ptr++;
     if (*ptr) {
      ptr1=ptr;
      if (ptr1[0]=='"') {
       ptr1++;
       ptr=ptr1;
       i=1;
      }
      else i=0;
      while ((*ptr1) && (!(((!i) && (isspace(*ptr1))) || ((i) && (*ptr1=='"')))))
       ptr1++;
      c=*ptr1;
      *ptr1=0;
      z=(char **) REALLOC(z,(2+numargs)*sizeof(*z));
      z[++numargs]=strdup(ptr);
      *ptr1=c;
      if ((i) && (*ptr1=='"')) ptr1++;
      ptr=ptr1;
     }
    } while (*ptr);
   }
   fclose(fp);
  }

  if (numargs<3) usage(argv);

  strcpy(newfile,z[1]);

  strcpy(reffile,z[2]);

  strcpy(sendfile,z[3]);

# if !defined JUNIOR
   BriefMsg=TRUE;
   Trace2file=InvMsg=FALSE;
# endif
  if (numargs>=4) {
   for (ptr=z[4];*ptr;ptr++)
    switch (toupper(*ptr)) {
#if !defined JUNIOR
     case 'B':
      BriefMsg=TRUE;
      break;
     case 'P':
      BriefMsg=FALSE;
      break;
     case 'I':
      InvMsg=TRUE;
      break;
     case 'T':
      Trace2file=TRUE;
      break;
#endif
     default:
      usage(argv);
      break;
    }
  }
# if !defined JUNIOR
   ProgMsg=!BriefMsg;

   if ((Trace2file) && (numargs<5)) {
    fprintf(stderr,"\n\rTracing requested but no trace file name.  Please respecify\n\r");
    EndOfPgr(1);
   }

   if (Trace2file) strcpy(diagoutput,z[5]);
# endif
  return(0);
 }


int need1(diff)
 int diff;
 {
  int gotit,mincnt,i;

  gotit=0;
  for (i=1;i<=4;i++)
   if (diff==gdiff[i]) {
    gdiffcnt[i]=gdiffcnt[i]+32;
    gotit=1;
   }
  if (gotit!=1) {
   mincnt=1;
   for (i=1;i<=4;i++)
    if (gdiffcnt[i]<gdiffcnt[mincnt]) mincnt=i;
   gdiffcnt[mincnt]=gdiffcnt[mincnt]+32;
   gdiff[mincnt]=diff;
  }
  return(0);
 }

int need2(diff1, diff2)
 int diff1, diff2;
 {
  int gotit1,gotit2,mincnt,i;

  gotit1=0;
  for (i=1;i<=4;i++)
   if (diff1==gdiff[i]) {
    gdiffcnt[i]=gdiffcnt[i]+32;
    gotit1=1;
   }
  gotit2=0;
  for (i=1;i<=4;i++)
   if (diff2==gdiff[i]) {
    gdiffcnt[i]=gdiffcnt[i]+32;
    gotit2=1;
   }
  if (gotit1!=1) {
   mincnt=1;
   for (i=1;i<=4;i++)
    if (gdiffcnt[i]<gdiffcnt[mincnt]) mincnt=i;
   gdiffcnt[mincnt]=gdiffcnt[mincnt]+32;
   gdiff[mincnt]=diff1;
  }
  if (gotit2!=1) {
   mincnt=1;
   for (i=1;i<=4;i++)
    if (gdiffcnt[i]<gdiffcnt[mincnt]) mincnt=i;
   gdiffcnt[mincnt]=gdiffcnt[mincnt]+32;
   gdiff[mincnt]=diff2;
  }
  return(0);
 }

int LookForMatch(x, i)
 int x,i;
 {
  int diffa,diffb,diffc,diffd,diffe,startnew=0,startold=0,diff=0,Switch=0,
      sw=0,chngesok=0,j,ii;

  diffa=0;
  diffb=0;
  diffc=0;
  diffd=0;
  diffe=0;
  startnew=(i*ISEG)-ISEG;
  startold=x-ISEG;
  j=1;
  while ((j<=ISEG) && (diffa==0)) {
   diff=bytesnew[j+startnew]-bytesold[j+startold];
   if (diff!=0) diffa=diff;
   j=j+1;
  }
  while ((j<=ISEG) && (diffb==0)) {
   diff=bytesnew[j+startnew]-bytesold[j+startold];
   if ((diff!=0) && (diff!=diffa)) diffb=diff;
   j=j+1;
  }
  while ((j<=ISEG) && (diffc==0)) {
   diff=bytesnew[j+startnew]-bytesold[j+startold];
   if ((diff!=0) && (diff!=diffa) && (diff!=diffb)) diffc=diff;
   j=j+1;
  }
  while ((j<=ISEG) && (diffd==0)) {
   diff=bytesnew[j+startnew]-bytesold[j+startold];
   if ((diff!=0) && (diff!=diffa) && (diff!=diffb) && (diff!=diffc)) diffd=diff;
   j=j+1;
  }
  while ((j<=ISEG) && (diffe==0)) {
   diff=bytesnew[j+startnew]-bytesold[j+startold];
   if ((diff!=0) && (diff!=diffa) && (diff!=diffb) && (diff!=diffc) && (diff!=diffd)) diffe=diff;
   j=j+1;
  }
  if (diffe==0) {
   matched[i]=x;
   if (diffa==0) {
    matchtype[i]=1;
    typeacnt=typeacnt+1;
    if (factor==1) lastfullmatch=x;
   }
   else {
    if (diffb==0) {
     matchtype[i]=2;
     typebcnt=typebcnt+1;
     differa[i]=diffa;
     need1(diffa);
     subtype[i]=0;
     for (ii=1;ii<=4;ii++)
      if (diffa==gdiff[ii]) subtype[i]=ii;
     if (subtype[i]==0) {
      fprintf(stderr,"\n\r**** ERROR - In LookForMatch (bug)\n\r");
      EndOfPgr(1);
     }
    }
    else {
     if (diffc==0) {
      matchtype[i]=3;
      typeccnt=typeccnt+1;
      need2(diffa, diffb);
      if (gdiff[1]==diffa) {
       Switch=0;
       if (diffb==gdiff[2]) subtype[i]=1;
       if (diffb==gdiff[3]) subtype[i]=2;
       if (diffb==gdiff[4]) subtype[i]=3;
      }
      else {
       if (gdiff[1]==diffb) {
	Switch=1;
	if (diffa==gdiff[2]) subtype[i]=1;
	if (diffa==gdiff[3]) subtype[i]=2;
	if (diffa==gdiff[4]) subtype[i]=3;
       }
       else {
	if (gdiff[2]==diffa) {
	 Switch=0;
	 if (diffb==gdiff[3]) subtype[i]=4;
	 if (diffb==gdiff[4]) subtype[i]=5;
        }
        else {
	 if (gdiff[2]==diffb) {
	  Switch=1;
	  if (diffa==gdiff[3]) subtype[i]=4;
          if (diffa==gdiff[4]) subtype[i]=5;
         }
         else {
          subtype[i]=6;
          if (gdiff[3]==diffa)
	   Switch=0;
          else
	   Switch=1;
         }
        }
       }
      }
      if (Switch==1) {
       sw=diffa;
       diffa=diffb;
       diffb=sw;
      }
      differa[i]=diffa;
      differb[i]=diffb;
     }
     else {
/*  If we have more than one pointer and one diff,  or two diff changes
    needed for these options,  we treat them as a no match. */
      chngesok=fchangesok(x, i, diffa, diffb, diffc, diffd);
      if (chngesok==0) {
       matchtype[i]=0;
       matched[i]=0;
      }
      else {
       matchtype[i]=4;
       if (diffd==0)
        typed1cnt=typed1cnt+1;
       else
        typed2cnt=typed2cnt+1;
       differa[i]=gdiff[1];
       differb[i]=gdiff[2];
       differc[i]=gdiff[3];
       differd[i]=gdiff[4];
      }
     }
    }
   }
  }

/* For a type B match,  we have in differa the new gdiffx value to be forced,
   depending on the subtype.
   For a type C match,  we have in differa and differb the new gdiffx and
   gdiffy values to be forced,  depending on the subtype.
   For a type D match,  we have in differa to differd the new  gidffx
   values to be forced (except where differd=0). */

  if (matched[i]!=0)
   for (ii=1;ii<=4;ii++)
    gdiffcnt[ii]=gdiffcnt[ii]/2;
  return(0);
 }

int Normal()
 {
  factor=1;
  skipval=1;
  resyncstate=0;
  return(0);
 }

int Resynch()
 {
  long estimatedposn;

/* We have had twenty successive no matches.
   Adjust factor and skipval */

  resyncstate=2;
  lastfullmatch=0;
  estimatedposn=(long) (2.0*((double) lengthold-(double) lengthnew)*(((double) (i*ISEG)+(double) done)/((double) lengthnew+(double) lengthold)));
  startoffset=(int) (estimatedposn-usedold+done);
  return(0);
 }

int OutputSub(byte)
 int byte;
 {
  if (n>=OBUF) {
   write(fp,obuff,n);
   n=0;
  }
  obuff[n++]=byte;
  outputcnt=outputcnt+1;
  return(0);
 }

int SetDiffer(k, x)
 int k,x;
 {
  int diffid,sendiff,dcase=0;

  if (x!=gdiff2[k]) {
   /* We need to change gdiff2(k) to x */
   diffid=(k+1)*16;
   gdiff2[k]=x;
   sendiff=x;
   dcase=0;
   if (sendiff<0) {
    dcase=1;
    sendiff=-sendiff;
   }
   if (sendiff>255) {
    fprintf(stderr,"\n\r**** ERROR - Difference is out of range (bug): %d\n\r",sendiff);
    EndOfPgr(1);
   }
   OutputSub(dcase+diffid);
   OutputSub(sendiff);
#  if !defined JUNIOR
    if (Trace2file) {
     fprintf(dgf," %ld ",i+donesegs);
     fprintf(dgf,"Change of diff  %d to  %d\n",k,x);
    }
#  endif
  }
  return(0);
 }

int GetBytes1(n)
 int n;
 {
  unsigned char *ptr;

  ptr=bytesold+1+n;
  if ((n0=read(fpold,(char *) ptr,((int) ((ISIZE-n)/IBUF))*IBUF))<0) n0=0;
# if !defined SUMCHK
   updcrc(ptr,n0,&oldcrc);
# endif
  return(n+n0);
 }

int GetBytes2(n)
 int n;
 {
  unsigned char *ptr;

  ptr=bytesnew+1+n;
  if ((n0=read(fpnew,(char *) ptr,((int) ((ISIZE-n)/IBUF))*IBUF))<0) n0=0;
# if defined SUMCHK
  {
   int i;

   for (i=0;i<n0;i++) {
    sumcheck1=(sumcheck1+(*(ptr++)))%255;
    sumcheck2=(sumcheck2+sumcheck1)%255;
   }
  }
# else
   updcrc(ptr,n0,&newcrc);
# endif
  return(n+n0);
 }

int main(argc,argv)
 int argc;
 char **argv;
 {
  putenv("TZ=GMT0");
  tzset();
  bytesold=MALLOC((ISIZE+1)*sizeof(*bytesold));
  memset(bytesold,0,(ISIZE+1)*sizeof(*bytesold));
  bytesnew=MALLOC((ISIZE+1)*sizeof(*bytesnew));
  memset(bytesnew,0,(ISIZE+1)*sizeof(*bytesnew));
  matched=MALLOC((SEGARRAYSIZE+1)*sizeof(*matched));
  memset(matched,0,(SEGARRAYSIZE+1)*sizeof(*matched));
  pointerchange=MALLOC((SEGARRAYSIZE+1)*sizeof(*pointerchange));
  memset(pointerchange,0,(SEGARRAYSIZE+1)*sizeof(*pointerchange));
  matchtype=MALLOC((SEGARRAYSIZE+1)*sizeof(*matchtype));
  memset(matchtype,0,(SEGARRAYSIZE+1)*sizeof(*matchtype));
  subtype=MALLOC((SEGARRAYSIZE+1)*sizeof(*subtype));
  memset(subtype,0,(SEGARRAYSIZE+1)*sizeof(*subtype));
  differa=MALLOC((SEGARRAYSIZE+1)*sizeof(*differa));
  memset(differa,0,(SEGARRAYSIZE+1)*sizeof(*differa));
  differb=MALLOC((SEGARRAYSIZE+1)*sizeof(*differb));
  memset(differb,0,(SEGARRAYSIZE+1)*sizeof(*differb));
  differc=MALLOC((SEGARRAYSIZE+1)*sizeof(*differc));
  memset(differc,0,(SEGARRAYSIZE+1)*sizeof(*differc));
  differd=MALLOC((SEGARRAYSIZE+1)*sizeof(*differd));
  memset(differd,0,(SEGARRAYSIZE+1)*sizeof(*differd));

  GetCommNames(argc,argv);

# if !defined JUNIOR
#  if !defined MSDOS && !defined _WINDOWS
    if ((ProgMsg) || (InvMsg))
#  endif
    {
     initcurses();
     cursor_off();
    }
# endif

  done=0;
  usedold=0;
  donesegs=0;
/* This is the amount of the new file that we have already done as a
   previous hunk. */

  dgf=NULL;

  valjl=1;
  for (i=8;i>=1;i--) {
   bitval[i]=valjl;
   valjl=valjl*2;
  }

# if !defined JUNIOR
   if (Trace2file)
    if ((dgf=fopen(diagoutput,"w"))==NULL) {
     fprintf(stderr,"\n\rUnable to open file %s\n\r",diagoutput);
     EndOfPgr(1);
    }

   if (ProgMsg) {
    vidclrscr();
    vidgotoxy(1,2);
    /* color 14,4,1 */
    CPRINTF("%s",version);
    /* color 15,1,1 */
    vidgotoxy(1,5);
    CPRINTF("Compressing %s using %s as a reference file",newfile,reffile);
    refresh();
   }
# endif

  if (BriefMsg) {
   printf("\r%s\n\r",version);
   printf("\n\r");
   sprintf(prevperc,"%5.1f",0.0);
   printf("\rPercent done is: %s%%",prevperc);
  }

  buff=MALLOC(IBUF);

  if ((fpold=open(reffile,O_RDONLY|O_BINARY))<0) {
   fprintf(stderr,"\n\r**** ERROR - Reference file %s does not exist\n\r",reffile);
   EndOfPgr(1);
  }
  lengthold=lseek(fpold,0L,SEEK_END);

  if ((fpnew=open(newfile,O_RDONLY|O_BINARY))<0) {
   fprintf(stderr,"\n\r**** ERROR - File to be compressed (%s) does not exist\n\r",newfile);
   EndOfPgr(1);
  }
  lengthnew=lseek(fpnew,0L,SEEK_END);

# if defined SUMCHK
   oldsumcheck1=0;
   oldsumcheck2=0;
   checked=0;

   lseek(fpold,0L,SEEK_SET);
   while ((checked<Nchecked) && ((n=read(fpold,(char *) buff,IBUF))>0)) {
    checked=checked+1;
    for (i=0;i<n;i++) {
     octval=buff[i];
     oldsumcheck1=(oldsumcheck1+octval)%255;
     oldsumcheck2=(oldsumcheck2+oldsumcheck1)%255;
    }
   }
# else
   updcrc(NULL,0,&oldcrc);
# endif

  lseek(fpold,0L,SEEK_SET);

  ICNT1=GetBytes1(0);

  endold=ISIZE;
  if (lengthold<ISIZE) endold=(int) lengthold;

# if !defined JUNIOR
   if (ProgMsg) {
    vidgotoxy(1,10);
    CPRINTF("First hunk of reference file loaded - total length is  %ld bytes",lengthold);
    refresh();
   }
# endif

  lseek(fpnew,0L,SEEK_SET);

# if defined SUMCHK
   sumcheck1=0;
   sumcheck2=0;
# else
   updcrc(NULL,0,&newcrc);
# endif

  ICNT2=GetBytes2(0);

  endnew=ISIZE;
  if (lengthnew<ISIZE) endnew=(int) lengthnew;

  newblocks=(int) (endnew/ISEG);

  if ((lengthold>ISIZE) || (lengthnew>ISIZE))
   if (newblocks>SEGARRAYSIZE1) newblocks=SEGARRAYSIZE1;

# if !defined JUNIOR
   if (ProgMsg) {
    vidgotoxy(1,11);
    CPRINTF("First hunk of main file loaded - total length is  %ld bytes",lengthnew);
    refresh();
   }
# endif

/* Now we initialise all variables,  ready to start the first hunk analysis */

  hunkstart=0;
  startoffset=0;
  factor=1;
  skipval=1;
  nomatchcnt=0;
  resyncstate=0;
  typeacnt=0L;
  typebcnt=0L;
  typeccnt=0L;
  typed1cnt=0L;
  typed2cnt=0L;
  nomatches=0;
  ptrchs=0;
  ptr=0;
  memset(gdiff,0,sizeof(gdiff));
  memset(gdiff2,0,sizeof(gdiff2));
  memset(gdiffcnt,0,sizeof(gdiffcnt));
  lastperc=0;
  lastfullmatch=0;
  investigate=0;
  cumptr=0;
  outputcnt=0;
  if ((fp=open(sendfile,O_RDWR|O_TRUNC|O_CREAT|O_BINARY,CREATEFLAGS))<0) {
   fprintf(stderr,"\n\rUnable to open file %s\n\r",sendfile);
   EndOfPgr(1);
  }

  /* Output the preamble text */

  obuff=MALLOC(OBUF);
  n=0;

# if defined SUMCHK
/*
There will be an initial block containing:
#if defined JLv1_1
 0.  A two-octet value of "JL",  followed by a one-octet format
     version number (currently hex 1).
#endif
 1.  a length count (one octet)for the next item.
#if defined JLv1_1
 2.  the full path name of the receiver's new file - default the old
     file name.
     (on decompression,  a file TEMP.TMP will be created in the current
     directory,  and then copied to the destination path when
     decompression is complete,  unless overridden by a different target).
#else
 2.  the full path name of the file that is to be compressed
     (on decompression,  a file TEMP.TMP will be created in the current
     directory,  and then copied to the original destination path when
     decompression is complete,  unless overridden by a different target).
#endif
 3.  two octets of sum check for the whole of this file;  the sum check
     is the standard one of SIGMA(Ai) and SIGMA(iAi),  all MOD 255.
 4.  a length count for the next item.
 5.  the full path name of the reference file (this can be overridden
     on decompression)
#if defined JLv1_1
                      default is the old file name.
#endif
#if defined JLv1_1
 6.  two octets of sum check for the first 10K of the reference file.
 7.  A two-octet value of "JL".
#else
 6.  two octets of sum check for the first 1K of the reference file.
#endif
*/
#  if defined JLv1_1
    n+=sprintf(obuff+n,"JL%c",1);
#  endif
   n+=sprintf(obuff+n,"%c%s",strlen(newfile),newfile);
   newoffsetsummcheck=n;
   n+=sprintf(obuff+n,"%c%c%c%s%c%c",
              0,0,strlen(reffile),reffile,oldsumcheck1,oldsumcheck2);
#  if defined JLv1_1
    n+=sprintf(obuff+n,"JL");
#  endif
# else
/*
  1.  'JL' signature
  2.  0x02 version nr
  3.  four octets with julian date of the file that is to be compressed
  4.  two octets with mode of the file
  5.  four octets of crc check for the whole of this file.
  6.  four octets that contain the size of the reference file.
  7.  four octets of crc check for the whole of the reference file.
  8.  A two-octet value of "JL".
*/
   stat(newfile,&statbuf);
   mode=statbuf.st_mode;
#  if defined MSDOS || defined _WINDOWS
    if (mode&S_IRUSR) mode|=S_IRGRP|S_IROTH;
    if (mode&S_IWUSR) mode|=S_IWGRP|S_IWOTH;
    if (mode&S_IXUSR) mode|=S_IXGRP|S_IXOTH;
#  endif
#  if defined TIMECORR1
    statbuf.st_mtime-=TIMECORR1;
#  endif
   n+=sprintf(obuff+n,"JL%c%c%c%c%c%c%c",2,
	      (char) (statbuf.st_mtime&0xff),(char) ((statbuf.st_mtime>>8)&0xff),
	      (char) ((statbuf.st_mtime>>16)&0xff),(char) ((statbuf.st_mtime>>24)&0xff),
	      (char) (mode&0xff),(char) ((mode>>8)&0xff));
#  if defined TIMECORR1
    statbuf.st_mtime+=TIMECORR1;
#  endif
   newoffsetsummcheck=n;
   n+=sprintf(obuff+n,"%c%c%c%c",0,0,0,0);
   n+=sprintf(obuff+n,"%c%c%c%c",
              (char) (lengthold&0xff),(char) ((lengthold>>8)&0xff),
              (char) ((lengthold>>16)&0xff),(char) ((lengthold>>24)&0xff));
   oldoffsetsummcheck=n;
   n+=sprintf(obuff+n,"%c%c%c%cJL",0,0,0,0);
# endif

  outputcnt=outputcnt+n;

/* We try to find a match for each ISEG of octets.
   We start the search at the corresponding position in the
   old file,  offset by startoffset.   Startoffset is updated on each
   to migrate towards the offset of the match.  We will go up to
   MAXINSERT*factor from startoffset,   working outwards in one byte
   units.
   Factor is initially one,  but gets adjusted if matches fail.
*/

   do {
    /* This is the outer loop,  LOOP UNTIL finished,  for each hunk. */

    for (i=1+hunkstart;i<=newblocks;i++) {
     matched[i]=0;
     matchtype[i]=0;
     pointerchange[i]=0;
     /* Assume not matched. */
     k1=0;
     c1=i*ISEG+startoffset;
     c2=i*ISEG+startoffset;
     while ((k1<=(MAXINSERT*((long) factor))) && (matched[i]==0) && ((i%skipval)==0)) {
      if ((c1<=endold) && (c1>=ISEG+lastfullmatch))
       LookForMatch((int) c1,i);
      if (matched[i]!=0) {
       offset=(int) (c1-i*ISEG);
       pointerchange[i]=(int) (offset-ptr);
       ptr=offset;
#      if defined JLv1_1
        if ((abs(startoffset-offset)<10) || (matchtype[i]==1))
         startoffset=offset;
#      endif
       startoffset=(startoffset+offset)/2;
      }
      else {
       if ((c2>=ISEG+lastfullmatch) && (c2<=endold))
        LookForMatch((int) c2,i);
       if (matched[i]!=0) {
	offset=(int) (c2-i*ISEG);
	pointerchange[i]=(int) (offset-ptr);
        ptr=offset;
#       if defined JLv1_1
         if ((abs(startoffset-offset)<10) || (matchtype[i]==1))
          startoffset=offset;
#       endif
        startoffset=(startoffset+offset)/2;
       }
      }
      k1=k1+1;
      c1=c1+1;
      c2=c2-1;
     }
     if (matched[i]==0) {
      nomatches=nomatches+1;
      switch (resyncstate) {
       case 0:
        nomatchcnt=nomatchcnt+1;
#       if !defined PNv1
         if (nomatchcnt==10) resyncstate=1;
#       else
         if (nomatchcnt>=10) resyncstate=1;
#       endif
        break;
       case 1:
        if ((i%skipval)==0) nomatchcnt=nomatchcnt+1;
        skipval=nomatchcnt-9;
        factor=(nomatchcnt-8)/2;
#       if !defined PNv1
         if (nomatchcnt==20)
#       else
         if (nomatchcnt>=20)
#       endif
         {
 	  Resynch();
          resyncstate=2;
         }
        break;
      }
     }
     else {
      switch (resyncstate) {
       case 0:
        nomatchcnt=0;
        break;
       case 1:
        nomatchcnt=nomatchcnt-1;
#       if !defined PNv1 && !defined JLv1_1
	 if (nomatchcnt==10) Normal();
#       else
	 if (nomatchcnt<=10) Normal();
#       endif
        skipval=1;
        break;
       case 2:
        skipval=1;
        resyncstate=1;
        break;
      }
      if (pointerchange[i]!=0) ptrchs=ptrchs+1;
     }
#    if !defined JUNIOR
      if (ProgMsg) {
       realperc=((((double) i)*ISEG+(double) done)*100.0)/(double) lengthnew;
       vidgotoxy(1,20);
       CPRINTF("Percent done is: %5.1f%%     ",realperc);
       vidgotoxy(1,21);
       CPRINTF("Resync state is:  %d No match count is:  %d          ",resyncstate,nomatchcnt);
       vidgotoxy(1,22);
       CPRINTF("Number of no matches:  %d out of  %ld segments",nomatches,i+donesegs);
       vidgotoxy(1,23);
       CPRINTF("Type A:  %ld  Type B:  %ld  Type C:  %ld Type D1:  %ld Type D2:  %ld",
               typeacnt,typebcnt,typeccnt,typed1cnt,typed2cnt);
       vidgotoxy(1,24);
       CPRINTF("Start offset is:  %d               ",startoffset);
       refresh();
      }
#    endif
     if (BriefMsg) {
      realperc=((((double) i)*ISEG+(double) done)*100.0)/(double) lengthnew;
      sprintf(perc,"%5.1f",realperc);
      if (strcmp(perc,prevperc)) {
       strcpy(prevperc,perc);
       printf("\rPercent done is: %s%%",perc);
      }
     }
    }

#   if !defined JUNIOR
     if (ProgMsg) {
      vidgotoxy(1,15);
      CPRINTF("%80s","");
      vidgotoxy(1,10);
      CPRINTF("%80s","");
      vidgotoxy(1,10);
      CPRINTF("Done analysis of a hunk of the file - outputing compressed format");
      vidgotoxy(1,11);
      CPRINTF("%80s","");
      refresh();
     }
#   endif

    if (BriefMsg) {
     realperc=((((double) i)*ISEG+(double) done)*100.0)/(double) lengthnew;
     if (realperc>100.0) realperc=100.0;
     sprintf(perc,"%5.1f",realperc);
     if (strcmp(perc,prevperc)) {
      strcpy(prevperc,perc);
      printf("\rPercent done is: %s%%",perc);
     }
    }

/*
The receivers state is set up with ptroffset=0,  diffa=0,  and
diffb=0 and done&=0 and usedold&=0.
These values are retained unless explicitly
changed.  The difference is new - old
*/

#   if !defined JUNIOR
     if ((InvMsg) && (investigate>=0)) {
      if (ProgMsg) {
       vidgotoxy(1,13);
       CPRINTF("Specify first i for investigation (0 end, -1 none, -2 all):");
       cursor_on();
       refresh();
      }
      else
       printf("\n\rSpecify first i for investigation (0 end, -1 none, -2 all):");
      scanf("%d",&investigate);
      if (ProgMsg) cursor_off();
      if (investigate==0) EndOfPgr(1);
     }
#   endif

/* We take each ISEG block in turn. */
    i=hunkstart;
    while (i<newblocks) {
     i=i+1;
/* If there is no match, we output 10nnnnnn followed by the nnnnnn sets of
   16 octets for up to 64 (nnnnnn of 0 means 64) segments.
   Note that 11nnnnnn is used for total matches (see below).  All other
   codes are 0xxxxxxx. */

    if (matched[i]==0) {
     nnn=1;
     j=i+1;
     while ((matched[j]==0) && (nnn<64) && (j<=newblocks)) {
      j=j+1;
      nnn=nnn+1;
     }
     k=nnn;
     if (nnn==64) nnn=0;
     nnn=nnn+128;
     OutputSub(nnn);
     newstart=(i-1)*ISEG;
     for (ik=1;ik<=k;ik++) {
      for (ii=1;ii<=ISEG;ii++)
       OutputSub(bytesnew[newstart+ii]);
      newstart=newstart+ISEG;
     }
     i=i+k-1;
#    if !defined JUNIOR
      if (Trace2file) {
       fprintf(dgf," %ld ",i+donesegs);
       fprintf(dgf," %d no match blocks\n",k);
       if ((InvMsg) && ((investigate==i+donesegs) || (investigate==-2))) {
        newstart=(i-1)*ISEG;
        oldstart=newstart+cumptr;
        for (ii=1;ii<=ISEG;ii++)
 	 fprintf(dgf," %d  %d\n",bytesnew[newstart+ii],bytesold[oldstart+ii]);
        if (investigate!=-2) {
 	 CPRINTF("\rSpecify next i for investigation (0 end, -1 none, -2 all):");
 	 cursor_on();
 	 refresh();
 	 scanf("%d",&investigate);
 	 cursor_off();
 	 if (investigate==0) EndOfPgr(1);
        }
       }
      }
#    endif
    }
    else {
/*
If there is a pointer change,  we need to signal it in the output.
We have four cases for the value of the ptr change:
             positive and less than (or equals) 256
             negative and less than (or equals) 256
             positive and over 256
             negative and over 256
We use 00000000,  00000001, 00010000, and 00010001 for these four cases.
In the first two cases,  we follow with a single octet,  and in the last
two with two octets.  In the case of the single octet,  zero means 256.
*/

     if (pointerchange[i]!=0) {
      ptr2=pointerchange[i];
      cumptr=cumptr+pointerchange[i];
      ptrcase=0;
      if (ptr2<0) {
       ptr2=-ptr2;
       ptrcase=1;
      }
      if (ptr2==256) ptr2=0;
      if (ptr2<=256) {
       OutputSub(ptrcase);
       OutputSub(ptr2);
#      if !defined JUNIOR
        if (Trace2file) {
 	 fprintf(dgf," %ld ",i+donesegs);
 	 fprintf(dgf," Pointer change to  %d\n",cumptr);
        }
#      endif
      }
      else {
       OutputSub(ptrcase+16);
       OutputSub(ptr2/256);
       OutputSub(ptr2%256);
#      if !defined JUNIOR
        if (Trace2file) {
 	 fprintf(dgf," %ld ",i+donesegs);
 	 fprintf(dgf," Pointer change to  %d\n",cumptr);
        }
#      endif
      }
     }

     if (matched[i]+usedold-i*ISEG-done!=cumptr) {
      fprintf(stderr,"\n\r**** ERROR - Cumulative pointer error (bug): %d %d\n\r",
              matched[i], cumptr);
      EndOfPgr(1);
     }

#    if !defined JUNIOR
      if (Trace2file)
       fprintf(dgf,"Dealing with a matchtype of  %d\n",matchtype[i]);
#    endif

/*
Next we look at whether a diffa, diffb, diffc,  diffd change is needed.
If a change of a diff is needed,  we
have the following cases for the diff:
             positive and less than 256
             negative and less than 256
We use 00100000 and 00100001 for these cases for diffa,  00110000 and
00110001 for these cases for diffb,  01000000 and 01000001 for diffc,
and 0101000 and 01010001 for diffd,  followed by a single byte which gives
the new diff value.
*/

     switch (matchtype[i]) {
      case 1:
       /* Type A - changes never needed, no action */
       break;
      case 2:
       /* Type B - may need a diffx change,  x depending on the sybtype */
       k=subtype[i];
       SetDiffer(k,differa[i]);
       break;
      case 3:
       /* Type C - may need a diffx and/or a diffy change,  depending
          on the subtype (1 to 6) */
       k=subtype[i];
       switch (k) {
        case 1:
        case 2:
	case 3:
         SetDiffer(1,differa[i]);
         SetDiffer(k+1,differb[i]);
         break;
        case 4:
        case 5:
         SetDiffer(2,differa[i]);
         SetDiffer(k-1,differb[i]);
         break;
        case 6:
         SetDiffer(3,differa[i]);
         SetDiffer(4,differb[i]);
         break;
        }
        break;
       case 4:
        /* Type D - may need up to two changes, could be any ones.  Check
           each one. */
        SetDiffer(1,differa[i]);
        SetDiffer(2,differb[i]);
        SetDiffer(3,differc[i]);
        SetDiffer(4,differd[i]);
        break;
     }

     switch (matchtype[i]) {
      case 1:
       /* Type A - total match */
/*
For a type A match,  we look
to see if the next block is also type A with no pointer change.  If so,
we count the number of blocks we can merge in,  up to a maximum of 64,
and output 11nnnnnn,  where n is the count of the number of merged - in
blocks
(nnnnnn all zeros means 64).
*/
       nnn=1;
       j=i+1;
       while ((matchtype[j]==1) && (nnn<64) && (pointerchange[j]==0) && (j<=newblocks)) {
        j=j+1;
        nnn=nnn+1;
       }
       k=nnn;
       i=i+k-1;
       if (nnn==64) nnn=0;
       nnn=nnn+128+64;
       OutputSub(nnn);
#      if !defined JUNIOR
        if (Trace2file) {
	 fprintf(dgf," %ld ",i+donesegs);
	 fprintf(dgf," %d type A blocks\n",k);
        }
#      endif
       break;
      case 2:
       /* Type B - match with a single diff value. */

/*
For a type B match,  we determine whether to use diffa,  b, c,  or d (based
on this segment alone,  and possibly with a diff change).  We then merge in
up to 8 segments (nnn=000 means 8) with the same pointer and diff value
(after juggling diffs if necessary).  The coding is 0nnn0010 for use of diffa
0nnn0011 for use of diffb,  0nnn0100 for use of diffc,  and 0nnn0101 for use of
diffd.  nnn is the number of segments merged in.  We then follow with a
string of bits,  one per byte in each of the segments,  where 0 means no
addition, and 1 means add in the selected diff.   Bits up to the next octet
boundary are ignored.
*/

       nnn=1;
       j=i+1;
       while ((matchtype[j]==2) && (nnn<8) && (pointerchange[j]==0) && (differa[j]==differa[i]) && (j<=newblocks)) {
        j=j+1;
        nnn=nnn+1;
       }
       k=nnn;
       if (nnn==8) nnn=0;
       testdiff=gdiff2[subtype[i]];
       dcase=subtype[i]+1;
       OutputSub(nnn*16+dcase);
#      if !defined JUNIOR
        if (Trace2file) {
	 fprintf(dgf," %ld ",i+donesegs);
	 fprintf(dgf," %d type B blocks.  Difference is  %d\n",k,testdiff);
        }
#      endif

/* We now output k sets of 2 octets,  showing where testdiff is to be
   added in for each of the k segments. */

       newstart=(i-1)*ISEG;
       oldstart=matched[i]-ISEG;
       for (ik=1;ik<=2*k;ik++) {
        bitmap=0;
        for (ii=1;ii<=ISEG/2;ii++) {
         if (bytesnew[newstart+ii]!=bytesold[oldstart+ii]) {
          if (bytesnew[newstart+ii]-bytesold[oldstart+ii]!=testdiff) {
	   fprintf(stderr,"\n\r**** ERROR - Type B difference is not differa (bug)\n\r");
	   EndOfPgr(1);
          }
	  bitmap=bitmap+(int) bitval[ii];
         }
        }
        oldstart=oldstart+ISEG/2;
        newstart=newstart+ISEG/2;
	OutputSub(bitmap);
       }
       i=i+k-1;
       break;
      case 3:
       /* Type C - match with two diff values */

/*
For a type C match,  we have six possible diff selections to use, coded as
follows (again,  merging in up to 8 possible segments):
           diffa and diffb    0nnn0110
           diffa and diffc    0nnn0111
           diffa and diffd    0nnn1000
           diffb and diffc    0nnn1001
           diffb and diffd    0nnn1010
           diffc and diffd    0nnn1011
We then follow with a string of bits,  one per byte in each of the segments,
where 0 means no addition,  and 10 means the first mentioned diff is added in,
and 11 means the second mentionned diff is added in.
*/

       diff1=differa[i];
       diff2=differb[i];
       nnn=1;
       j=i+1;
       while ((matchtype[j]==3) && (nnn<8) && (pointerchange[j]==0) && (differa[j]==diff1) && (differb[j]==diff2) && (j<=newblocks)) {
        j=j+1;
        nnn=nnn+1;
       }
       k=nnn;
       if (nnn==8) nnn=0;
       nnn=nnn*16+subtype[i]+5;
       OutputSub(nnn);
#      if !defined JUNIOR
        if (Trace2file) {
	 fprintf(dgf," %ld ",i+donesegs);
	 fprintf(dgf," %d type C blocks.  Differences are  %d and  %d\n",k,diff1,diff2);
        }
#      endif

/* We now output k sets of bitstrings,  showing where diff1 (10) and
   diff2 (11) or neither (0) are to be added in for each of the k segments. */

       newstart=(i-1)*ISEG;
       oldstart=matched[i]-ISEG;
       bitstring[0]=0;
       for (ik=1;ik<=k;ik++) {
	for (ii=1;ii<=ISEG;ii++) {
	 n0=bytesnew[newstart+ii]-bytesold[oldstart+ii];
	 if (n0==0) strcat(bitstring,"0");
	 else if (n0==diff1) strcat(bitstring,"10");
	 else if (n0==diff2) strcat(bitstring,"11");
	 else {
	  fprintf(stderr,"\n\r**** ERROR - Type C difference is not differa or differb (bug)\n\r");
	  EndOfPgr(1);
	 }
	}
	oldstart=oldstart+ISEG;
	newstart=newstart+ISEG;
       }
       strcat(bitstring,"0000000");
       blen=strlen(bitstring);
       blen=8*(blen/8);
       bitstring[blen]=0;
       outc=0;
       j=0;
       jj=0;
       bitmap=0;
       while (j<blen) {
        j=j+1;
        jj=jj+1;
	if (bitstring[j-1]=='1') bitmap=bitmap+(int) bitval[jj];
        if (jj==8) {
         jj=0;
	 OutputSub(bitmap);
	 bitmap=0;
        }
       }
       i=i+k-1;
       break;
      case 4:
       /* Type D */
/*
For a type D match,  we encode the segments
as 0nnn1100 (for up to 8 segments) where we have four differs,  and
0nnn1101 where diffa is omitted, 0nnn1110 where diffb is omitted,  0nnn1111
where diffc is omitted.  For diffd omitted,  we have no code space left,
and treat that as if it were a four differ (code 0nnn1100).
This is followed by a bitstring for each
octet in each of the segments,  where we have 0 if no diff is to
be added in,  then,  for the three differs in use,
100 if the first is to be added in, 101 for the second,  and 11 for the third.
For four differs,  we have
100 if diffa is to be added in,  101 for diffb,  110 for diffc,
111 for diffd.
*/

       diff1=differa[i];
       diff2=differb[i];
       diff3=differc[i];
       diff4=differd[i];

       nnn=1;
       j=i+1;
       while ((matchtype[j]==4) && (nnn<8) && (pointerchange[j]==0) && (differa[j]==diff1) && (differb[j]==diff2) && (differc[j]==diff3) && (differd[j]==diff4) && (j<=newblocks)) {
        if (subtype[j]!=subtype[i]) subtype[i]=0; /* use all four if necessary */
        j=j+1;
        nnn=nnn+1;
       }

       if (subtype[i]==4) subtype[i]=0; /* This is because we ran out of code space */

       switch (subtype[i]) {
	case 0:
	 break;
	case 1:
	 diff1=differb[i];
	 diff2=differc[i];
	 diff3=differd[i];
	 diff4=0;
	 break;
	case 2:
	 diff2=differc[i];
	 diff3=differd[i];
	 diff4=0;
	 break;
	case 3:
	 diff3=differd[i];
	 diff4=0;
	 break;
	case 4:
	 break;
       }

       k=nnn;
       if (nnn==8) nnn=0;
       nnn=nnn*16+12;
       nnn=nnn+subtype[i];
       OutputSub(nnn);
#      if !defined JUNIOR
        if (Trace2file) {
 	 fprintf(dgf," %ld ",i+donesegs);
 	 if (subtype[i]==0)
 	  fprintf(dgf," %d type D2 blocks.  Differences are  %d and  %d and  %d and  %d\n",k,diff1,diff2,diff3,diff4);
 	 else
 	  fprintf(dgf," %d type D1 blocks.  Differences are  %d and  %d and  %d and  %d\n",k,diff1,diff2,diff3,diff4);
        }
#      endif

/* We now output k sets of bitstrings,  showing where diff1 (100),
   diff2 (101),  diff3 (110 - or 11 if only three differs), diff4 (111)
   or neither (0) are to be added in for each of the k segments. */

       strcpy(diff3str,"110");
       if (subtype[i]!=0) strcpy(diff3str,"11");
       newstart=(i-1)*ISEG;
       oldstart=matched[i]-ISEG;
       bitstring[0]=0;
       for (ik=1;ik<=k;ik++) {
	for (ii=1;ii<=ISEG;ii++) {
	 n0=bytesnew[newstart+ii]-bytesold[oldstart+ii];
	 if (n0==0) strcat(bitstring,"0");
	 else if (n0==diff1) strcat(bitstring,"100");
	 else if (n0==diff2) strcat(bitstring,"101");
	 else if (n0==diff3) strcat(bitstring,diff3str);
	 else if (n0==diff4) strcat(bitstring,"111");
	 else {
	  fprintf(stderr,"\n\r**** ERROR - Type D difference is not diffa or diffb or diffc or diffd (bug)\n\r");
	  EndOfPgr(1);
	 }
        }
        oldstart=oldstart+ISEG;
        newstart=newstart+ISEG;
       }
       strcat(bitstring,"0000000");
       blen=strlen(bitstring);
       blen=8*(blen/8);
       bitstring[blen]=0;
       j=0;
       jj=0;
       bitmap=0;
       while (j<blen) {
        j=j+1;
        jj=jj+1;
	if (bitstring[j-1]=='1') bitmap=bitmap+(int) bitval[jj];
        if (jj==8) {
         jj=0;
	 OutputSub(bitmap);
	 bitmap=0;
        }
       }
       i=i+k-1;
       break;
     }
    }
   }

/* Now loop to do another hunk if necessary */
   finished=0;
   if (lengthnew-(newblocks+donesegs)*ISEG<ISEG) {
    finished=1;
#   if !defined JUNIOR
     if (ProgMsg) {
      vidgotoxy(1,20);
      CPRINTF("Percent done is: %5.1f%%     ",100.0);
      vidgotoxy(1,21);
      CPRINTF("Resync state is:  %d No match count is:  %d          ",resyncstate,nomatchcnt);
      vidgotoxy(1,22);
      CPRINTF("Number of no matches:  %d out of  %ld segments",nomatches,i+donesegs);
      vidgotoxy(1,23);
      CPRINTF("Type A:  %ld  Type B:  %ld  Type C:  %ld Type D1:  %ld Type D2:  %ld",
              typeacnt,typebcnt,typeccnt,typed1cnt,typed2cnt);
      vidgotoxy(1,24);
      CPRINTF("Start offset is:  %d               ",startoffset);
      refresh();
     }
#   endif

    if (BriefMsg)
     printf("\rPercent done is: %5.1f%%",100.0);
   }
   else {
    /* Prepare for next hunk */

    hunkstart=ISIZE3/ISEG;

    /* move new array down by ISIZE2,  and oldarray down by
       ISIZE2+startoffset,  and decrement ptr and startoffset by startoffset
       and signal the move in the sendfile. */

    done=done+ISIZE2;
    donesegs=done/ISEG;

    Move=ISIZE2+startoffset;
    if (Move<0) Move=0;
    usedold=usedold+Move;

    /* Signal a new hunk */
/*
Where we have discarded some old file and refilled the buffers,  we
signal this
in the output by putting out a single octet of 01100000 followed by
two octets giving the amount of the move. */

    OutputSub(96);
    OutputSub(Move/256);
    OutputSub(Move%256);

    ptr=ptr+(ISIZE2-Move);
    startoffset=startoffset+(ISIZE2-Move);
    if (lastfullmatch>Move) lastfullmatch=lastfullmatch-Move;
    else lastfullmatch=0;

    if (endold<Move+ISEG) {
     fprintf(stderr,"\n\r**** ERROR - Files are too different\n\r");
     EndOfPgr(1);
    }

    endold=endold-Move;
    for (i=1;i<=endold;i++)
     bytesold[i]=bytesold[i+Move];

    endnew=endnew-ISIZE2;
    for (i=1;i<=endnew;i++)
     bytesnew[i]=bytesnew[i+ISIZE2];

#   if !defined JUNIOR
     if (Trace2file)
      fprintf(dgf,"Move of new by  %d  and of old by  %d\n",ISIZE2,Move);
#   endif

/* Now read in as much as possible of the files to fill the buffers. */

    ICNT1=GetBytes1(endold);

    endold=ISIZE;
    if (lengthold-usedold<ISIZE) endold=(int) (lengthold-usedold);

    ICNT2=GetBytes2(endnew);

    endnew=ISIZE;
    if (lengthnew-done<ISIZE) endnew=(int) (lengthnew-done);

    newblocks=endnew/ISEG;

    if ((lengthold-usedold>ISIZE) || (lengthnew-done>ISIZE))
     if (newblocks>SEGARRAYSIZE1) newblocks=SEGARRAYSIZE1;

#   if !defined JUNIOR
     if (ProgMsg) {
      vidgotoxy(1,10);
      CPRINTF("%80s","");
      vidgotoxy(1,10);
      CPRINTF("Next hunk of files loaded - proceeding with analysis");
      vidgotoxy(1,11);
      CPRINTF("%80s","");
      refresh();
     }
#   endif

/*  This ends the preparation for the next hunk. */
   }
  } while (!finished);

/*
Finally,  we have to cope with the residual set of up to 15 octets at the
end of the file.   We simply output 01100001,  then a single octet saying
how many follow,  then the octets.  If there are none,  we still output
the single octet and the null count.
*/

  extras=endnew-newblocks*ISEG;

  OutputSub(97);
  OutputSub(extras);
  for (i=1;i<=extras;i++)
   OutputSub(bytesnew[newblocks*ISEG+i]);

# if !defined JUNIOR
   if (Trace2file) {
    fprintf(dgf,"\n");
    fprintf(dgf,"Statistics for the compression (done using %d byte segments) are\n",ISEG);
    fprintf(dgf,"         Type A matches:  %.1f%%\n",
 	    (((double) typeacnt)*ISEG*1000.0)/(double) lengthnew/10.0);
    fprintf(dgf,"         Type B matches:  %.1f%%\n",
 	    (((double) typebcnt)*ISEG*1000.0)/(double) lengthnew/10.0);
    fprintf(dgf,"         Type C matches:  %.1f%%\n",
 	    (((double) typeccnt)*ISEG*1000.0)/(double) lengthnew/10.0);
    fprintf(dgf,"         Type D1 matches:  %.1f%%\n",
 	    (((double) typed1cnt)*ISEG*1000.0)/(double) lengthnew/10.0);
    fprintf(dgf,"         Type D2 matches:  %.1f%%\n",
 	    (((double) typed2cnt)*ISEG*1000.0)/(double) lengthnew/10.0);
    fprintf(dgf,"         Failed matches:  %.1f%%\n",
 	    (((double) nomatches)*ISEG*1000.0)/(double) lengthnew/10.0);
    fprintf(dgf,"         Pointer changes: %d\n\n",ptrchs);
   }

   if (ProgMsg) {
    vidgotoxy(1,13);
    CPRINTF("%80s","");
    vidgotoxy(1,13);
    /* color 14,4,1 */
    CPRINTF("Compression complete.  Number of octets output is %ld",outputcnt);
    outjl=lengthnew;
    outjl=(outjl*10)/outputcnt;
    vidgotoxy(18,15);
    CPRINTF("This is a compression ratio of  %f to 1",outjl/10.0);
    vidgotoxy(18,16);
    CPRINTF("Use now a compression program to obtain maximum compression.");
    vidgotoxy(1,18);
    CPRINTF("Forward compression finished.");
    vidgotoxy(1,24);
    refresh();
   }

   if (Trace2file) {
    fprintf(dgf,"Compression complete.  Number of octets output is  %ld\n",outputcnt);
    outjl=lengthnew;
    outjl=(outjl*10)/outputcnt;
    fprintf(dgf,"                  This is a compression ratio of  %f to 1\n",outjl/10.0);
   }
# endif

  if (BriefMsg) {
   outjl=(lengthnew*10)/outputcnt;
   printf("\n\rForward compression complete.  Compression ratio is  %f to 1\n\r",outjl/10.0);
  }

  EndOfPgr(0);
  return(0);
 }