#define JLv1_1

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <malloc.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <time.h>
#if defined _MSC_VER
# include <sys/utime.h>
#else
# include <utime.h>
#endif

#if !defined MSDOS
# if defined __BORLANDC__ || defined __HIGHC__
#  define MSDOS
# endif
#endif

#if defined MSDOS || defined _WINDOWS
# include <io.h>
# include <conio.h>
# define refresh()
# define CREATEFLAGS (S_IREAD|S_IWRITE)
# define PATH_DELIMITER "\\"
# if defined TIMECORR1
   statbuf.st_mtime+=TIMECORR1;
# endif
#else
# if !defined JUNIOR
#  include <curses.h>
# endif
# define O_BINARY 0
# define CREATEFLAGS (S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH|S_IWOTH)
# define PATH_DELIMITER "/"
#endif

#if !defined JUNIOR
# include "dirvid.h"
# include "print.h"
#endif
#if defined LONGNAME
# include "longname.h"
#endif
#if defined FORTIFY
# include "fortify.h"
#endif

#define IBUF 100
/* IBUF is the input buffer size for obtaining the ascii value of each
   byte.  Speed seems relatively independent of the IBUF size. */

#define OBUF 1024

#define ISIZE 32000
/* This is the hunk of the old file that we work with.   We read in the first
   32000 (or all if less),  and discard as commanded in the compressed format.
   This is a parameter of the FCM format. */

#define ISIZE2 24000
/* This is the amount of FCM we do before moving it. */

#define ISIZE3 12000
/* And this is the amount we move it down each time. */

#define ISEG 16
/* This is the size of typeA and no match blocks,  and is a parameter of the
   compressed (FCM) format. */

#if defined JLv1_1
# define Nchecked 100
#else
# define Nchecked 10
#endif

#if !defined FALSE
# define FALSE 0
#endif

#if !defined TRUE
# define TRUE 1
#endif

unsigned char *bytesold;
/* This is the array of bytes from the old version */

unsigned char *bytesfcm;
/* This is the array of bytes from the FCM format file */

struct {
 char bits[8];
} bits[256];
/* holds the bitstring for each of the values of an octet. */

int gdiff[4+1];
/* Used to hold the global difference values we maintain. */

char *obuff,newfile[128],reffile[128],fcmfile[128],
     *version="JLUNPAK Copyright IT Institute/P. Notebaert - Forward decompression program V2.0",
     perc[6],prevperc[6];

#if defined JUNIOR
# define BriefMsg 1
#else
  char BriefMsg,ProgMsg,Trace2file,diagoutput[128];
#endif

unsigned char *buff;

int i,fp=-1,fpold=-1,fpfcm=-1,n,n0,realendfcm,endfcm,fcmpointer,octlen,ijl,
    checked,trace,doneadd,ptr,ICNT1,ICNT2,octval,
    endold,ptroffset,cnt,reallyfinished,code,codecase,
    count,subcode,code1,octets,negate,diffindx,diffindx1,diffindx2,diffindx3,
    diffindx4,Move,copybytes,bitstringptr,numocts,finished;
#if !defined JUNIOR
 int cursesdefined;
#endif

#if defined SUMCHK
 int sumcheckval1,sumcheckval2,oldsumcheckval1,oldsumcheckval2,
     sumcheck1,sumcheck2,oldsumcheck1,oldsumcheck2;
#else
 unsigned long crcval,oldcrcval,crc,oldcrc,refsize;
 unsigned short mode;
 time_t filetime;
#endif

long done,usedold,donefcm,lengthfcm,lengthold,lastperc,outputcnt;

double realperc;

FILE *dgf=NULL;

extern unsigned long updcrc();

void EndOfPgr(i)
 int i;
 {
  if (fp>=0) {
#  if !defined SUMCHK
    struct utimbuf utimbuf;
#  endif

   if (n) write(fp,obuff,n);
   close(fp);
#  if !defined SUMCHK
#   if defined TIMECORR1
     filetime+=TIMECORR1;
#   endif
    utimbuf.actime=utimbuf.modtime=filetime;
    utime(newfile,&utimbuf);
    chmod(newfile,mode);
#  endif
  }
  n=0;
  if (fpfcm>=0) close(fpfcm);
  if (fpold>=0) close(fpold);
  if (dgf!=NULL) fclose(dgf);
  if (i) unlink(newfile);
# if !defined JUNIOR
   if (cursesdefined) {
    cursor_on();
#   if !defined MSDOS && !defined _WINDOWS
     refresh();
     endwin();
#   endif
   }
# endif
  exit(i);
 }

void *MALLOC(size)
 size_t size;
 {
  void *pointer;

  if ((pointer=(void *) malloc(size))==NULL) {
   fprintf(stderr,"\n\rmalloc(): out of memory\n\r");
   EndOfPgr(1);
  }
  return(pointer);
 }

void *REALLOC(oldptr,size)
 void *oldptr;
 size_t size;
 {
  void *pointer;

  if (oldptr==NULL) pointer=MALLOC(size);
  else if ((pointer=(void *) realloc(oldptr,size))==NULL) {
   fprintf(stderr,"\n\rrealloc(): out of memory\n\r");
   EndOfPgr(1);
  }
  return(pointer);
 }

#if !defined JUNIOR
static void initcurses()
 {
# if !defined MSDOS && !defined _WINDOWS
   if (!cursesdefined) {
    if (initscr()==NULL) {
     int handle;
     char buf[1];

     fprintf(stderr,"\n\rUnable to work with curses\n\r");
#    if defined M_TERMCAP
      if ((handle=open("/etc/termcap",O_RDONLY))<0)
       fprintf(stderr," Can not access /etc/termcap (rights ?) !\n\r");
      else if (read(handle,buf,1)!=1)
       fprintf(stderr," Can not read in /etc/termcap (rights ?) !\n\r");
      else close(handle);
#    endif
     EndOfPgr(1);
    }
   }
   scrollok(stdscr,TRUE);
   cbreak();
   noecho();
   nonl();
# endif
  cursesdefined=TRUE;
 }
#endif

/*
 This is part of the eventual documentation,  and describes the
 compressed format based on this approach.

 There will be an initial block

 Decompression will be abandonned if the reference file is not found
 on the receiving system,  with the correct sumcheck.

 The receivers state is set up with ptroffset=0, gdiff(1)=0, gdiff(2)=0,
 gdiff(3)=0,  gdiff(4)=0.   These values are retained unless explicitly
 changed.  The target value is old plus difference. (Difference is new - old).
 The old values to be used are at cnt+ptroffset+1 to
 cnt+ptroffset+ISEG,  where cnt is the number
 of new octets generated so far.  A positive pointer change is an addition
 to ptroffset.
 (A ptroffset is old posn - new posn for compression).

 The following algorithm determines the compressed format:

 We take each ISEG block in turn.

 If there is no match, we output 10nnnnnn followed by the nnnnnn sets of
 16 octets for up to 64 (nnnnnn of 0 means 64) segments.
 Note that 11nnnnnn is used for total matches (see below).  All other
 codes are 0xxxxxxx.
 On decompression,  we branch on bit 1 equals 1 or 0,  and if bit 1 is
 1,  then we branch on 10 or 11.  For 10,  we pick up nnnnnn,  and copy
 ISEG*nnnnnn octetcs from the fcm to the target.

 If there is a pointer change,  we need to signal it in the output.
 We have four cases for the value of the ptr change:
              positive and less than (or equals) 256
              negative and less than (or equals) 256
              positive and over 256
              negative and over 256
 We use 00000000,  00000001, 00010000, and 00010001 for these four cases.
 In the first two cases,  we follow with a single octet,  and in the last
 two with two octets.  In the case of the single octet,  zero means 256.
 On decompression,  we are in the first bit zero case,  and branch first on
 the bottom four bits,  taking the 0 and 1 cases here.  For zero,  we are
 collecting a positive value, and for 1 a negative.  Next we branch on the
 value of nnn in 0nnn000x.  For 0 we have a single octet following and
 a value to be added (after negation if necessary) to ptroffset.  For 1
 we have a two octet value (most significant first).

 Next we look at whether a diffa, diffb, diffc,  diffd change is needed.
 If a change of a diff is needed,  we
 have the following cases for the diff:
              positive and less than 256
              negative and less than 256
 We use 00100000 and 00100001 for these cases for diffa,  00110000 and
 00110001 for these cases for diffb,  01000000 and 01000001 for diffc,
 and 0101000 and 01010001 for diffd,  followed by a single byte which gives
 the fcm diff value.
 On decompression, this is the nnn=2 (diffa), 3 (diffb), 4 (diffc) and
 5 (diffd) cases described under pointer above.

 This completes the use of the 0mmm0000 and 0mmm0001 values
 except for 110 which is used in termination below,  and 111 which is spare.
 Remaining codes are
 0mmmxxxx where xxxx is above 0001.

 In all cases,  apart from no match,  we first code any pointer change
 needed,  then any one or more diff changes that are needed,  then we code
 the type.

 For a type A match,  we look
 to see if the next block is also type A with no pointer change.  If so,
 we count the number of blocks we can merge in,  up to a maximum of 64,
 and output 11nnnnnn,  where n is the count of the number of merged - in
 blocks
 (nnnnnn all zeros means 64).
 On decompression,  this is the branch from first bit 1,  first two 11.
 We copy ISEG*nnnnnn octets from the old file,  starting at cnt +
 ptroffset+1.

 For a type B match,  we determine whether to use diffa,  b, c,  or d (based
 on this segment alone,  and possibly with a diff change).  We then merge in
 up to 8 segments (nnn=000 means 8) with the same pointer and diff value
 (after juggling diffs if necessary).  The coding is 0nnn0010 for use of diffa
 0nnn0011 for use of diffb,  0nnn0100 for use of diffc,  and 0nnn0101 for use of
 diffd.  nnn is the number of segments merged in.  We then follow with a
 string of bits,  one per byte in each of the segments,  where 0 means no
 addition, and 1 means add in the selected diff.   Bits up to the next octet
 boundary are ignored.
 On decompression,  we use nnn to determine the number of octets to be
 produced (16*nnn),  and then take as many octets as necessary to give
 us the additions of diffa,  b etc.  We start the old at cnt+ptroffset+1
 and we set new to old+diff. (Diff was defined as new - old)

 For a type C match,  we have six possible diff selections to use, coded as
 follows (again,  merging in up to 8 possible segments):
            diffa and diffb    0nnn0110
            diffa and diffc    0nnn0111
            diffa and diffd    0nnn1000
            diffb and diffc    0nnn1001
            diffb and diffd    0nnn1010
            diffc and diffd    0nnn1011

 We then follow with a string of bits,  one per byte in each of the segments,
 where 0 means no addition,  and 10 means the first mentioned diff is added in,
 and 11 means the second mentionned diff is added in.
 On decompression,  this is values 6 to 11 of the bottom four octets. We
 proceed as for case B, except that we need to use two diffs,  diff1 and diff2
 taken from diffa to diffd according to the case being considered.

 For a type D match,  we encode the segments
 as 0nnn1100 (for up to 8 segments) where we have four differs,  and
 0nnn1101 where diffa is omitted, 0nnn1110 where diffb is omitted,  0nnn1111
 where diffc is omitted.  For diffd omitted,  we have no code space left,
 and treat that as if it were a four differ (code 0nnn1100).
 This is followed by a bitstring for each
 octet in each of the segments,  where we have 0 if no diff is to
 be added in,  then,  for the three differs in use,
 100 if the first is to be added in, 101 for the second,  and 11 for the third.
 For four differs,  we have
 100 if diffa is to be added in,  101 for diffb,  110 for diffc,
 111 for diffd.
 On decompression,  this is again similar to CASE C,  except that we have
 three or four differs depending on the value 12 (four) or 13 to 16 (three)
 of the case.  The value of the case says which differ is omitted.

 Finally,  we have to cope with the residual set of up to 15 octets at the
 end of the file.   We simply output 00001110,  then a single octet saying
 how many follow,  then the octets.  If there are none,  we still output
 the single octet and the null count.  On decompression,  we copy octets
 across.

 Where we have discarded some old file and refilled the buffers,  we
 signal this
 in the output by putting out a single octet of 00011110 followed by
 two octets giving the amount of the move.
 On decompression,  this is a signal to move the new file by the full
 12K,  and to move the old file by the specified amount.

 This ends the use of the 0nnnxxxx codes.  The value 1111 of xxxx is
 spare.

 Thus,  we get the following counts:
     first no match                  17
     subsequent no match (up to 128) 16
     ptr change (<256)                2
     ptr change (>256)                3
     diff change                      2
     type A                           1 (?+3-ptr change)
     subsequent A (up to 128)         0
     type B                           3 (?+5-ptr+1 diff)
     subsequent B (up to 8)           2
     type C                           4 to 5 bytes (?+7-ptr+2 diff)
     subsequent C (up to 8)           2 to 4 bytes
     type D or E                      4 to 7 bytes (?+5/4-ptr/diff+ diff)
 NOTE - We recognise D or E only if there is at most 1 ptr and one diff,  or
 two diff changes.
*/

int GetBit()
 {
  static char bitstring[8];
  char bit;

  if (bitstringptr==0) {
   memcpy(bitstring,bits[bytesfcm[fcmpointer]].bits,8);
   bitstringptr=1;
   fcmpointer=fcmpointer+1;
  }
  bit=bitstring[bitstringptr-1];
  bitstringptr=bitstringptr+1;
  if (bitstringptr==9) bitstringptr=0;
  return((bit=='1') ? 1 : 0);
 }

char *basename(file)
 char *file;
 {
  char *pointer,*pointer1;

  pointer=strrchr(file,'.');
  pointer1=strrchr(file,*PATH_DELIMITER);
  if ((pointer!=NULL) && ((pointer1==NULL) || (pointer-pointer1>0))) *pointer='\0';
  if (pointer1!=NULL) pointer1++;
  else pointer1=file;
  return(pointer1);
 }

int usage(argv)
 char **argv;
 {
  printf("\r%s\n\r\n",version);
  printf("Usage: %s new-file old-file diff-file%s\n\r",
	 basename(argv[0]),
#if defined JUNIOR
         ""
#else
         " [B|P][T trace-file]"
#endif
        );
  printf( "         new-file: file to be compressed (ie newest version)\n\r");
  printf( "         old-file: reference file (ie old version)\n\r");
  printf( "        diff-file: file that holds the differences\n\r");
# if !defined JUNIOR
   printf("           B or P: optional verbose level; P=progress, B=brief (default)\n\r");
   printf("     T trace-file: optional trace file\n\r");
# endif
  printf( " or\n\r");
  printf( "       %s @ctlfile\n\r",basename(argv[0]));
  printf( "           with ctlfile a controlfile which contains the arguments as described\n\r");
  printf( "           above.\n\r");
  EndOfPgr(1);
  return(0);
 }

int GetCommNames(argc,argv)
 int argc;
 char **argv;
 {
  char **z,*ptr;
  int numargs;

  z=argv;
  numargs=argc-1;

  if ((argc==2) && (argv[1][0]=='@')) {
   FILE *fp;
   char str[1024],*ptr1,c;
   int i;

   if ((fp=fopen(argv[1]+1,"r"))==NULL) {
    fprintf(stderr,"Unable to open control file %s\n",argv[1]+1);
    EndOfPgr(1);
   }
   numargs=0;
   z=NULL;
   while (fgets(str,sizeof(str),fp)!=NULL) {
    if ((ptr=strchr(str,'\n'))!=NULL) *ptr=0;
    ptr=str;
    do {
     while (isspace(*ptr)) ptr++;
     if (*ptr) {
      ptr1=ptr;
      if (ptr1[0]=='"') {
       ptr1++;
       ptr=ptr1;
       i=1;
      }
      else i=0;
      while ((*ptr1) && (!(((!i) && (isspace(*ptr1))) || ((i) && (*ptr1=='"')))))
       ptr1++;
      c=*ptr1;
      *ptr1=0;
      z=(char **) REALLOC(z,(2+numargs)*sizeof(*z));
      z[++numargs]=strdup(ptr);
      *ptr1=c;
      if ((i) && (*ptr1=='"')) ptr1++;
      ptr=ptr1;
     }
    } while (*ptr);
   }
   fclose(fp);
  }

  if (numargs<3) usage(argv);

  strcpy(newfile,z[1]);

  strcpy(reffile,z[2]);

  strcpy(fcmfile,z[3]);

# if !defined JUNIOR
   BriefMsg=TRUE;
   Trace2file=FALSE;
# endif
  if (numargs>=4) {
   for (ptr=z[4];*ptr;ptr++)
    switch (toupper(*ptr)) {
#if !defined JUNIOR
     case 'B':
      BriefMsg=TRUE;
      break;
     case 'P':
      BriefMsg=FALSE;
      break;
     case 'T':
      Trace2file=TRUE;
      break;
#endif
     default:
      usage(argv);
      break;
    }
  }
# if !defined JUNIOR
   ProgMsg=!BriefMsg;

   if ((Trace2file) && (numargs<5)) {
    fprintf(stderr,"\n\rTracing requested but no trace file name.  Please respecify\n\r");
    EndOfPgr(1);
   }

   if (Trace2file) strcpy(diagoutput,z[5]);
# endif
  return(0);
 }

int OutputSub(octetvalue)
 int octetvalue;
 {
  if (n>=OBUF) {
   write(fp,obuff,n);
   n=0;
  }

  if (trace==1) {
   if ((octetvalue<0) || (octetvalue>255)) {
    fprintf(stderr,"\n\r**** ERROR - FCM format error - Octetvalue out of range (bug) %d\n\r",octetvalue);
    EndOfPgr(1);
   }
  }
  obuff[n]=octetvalue;
# if defined SUMCHK
   sumcheck1=(sumcheck1+octetvalue)%255;
   sumcheck2=(sumcheck2+sumcheck1)%255;
# else
   updcrc(obuff+n,1,&crc);
# endif
  n++;
  outputcnt=outputcnt+1;
  return(0);
 }

int GetBytes1(n)
 int n;
 {
  unsigned char *ptr;

  ptr=bytesold+1+n;
  if ((n0=read(fpold,(char *) ptr,((int) ((ISIZE-n)/IBUF))*IBUF))<0) n0=0;
# if !defined SUMCHK
   updcrc(ptr,n0,&oldcrc);
# endif
  return(n+n0);
 }

int GetBytes2(n)
 int n;
 {
  if ((n0=read(fpfcm,(char *) (bytesfcm+1+n),((int) ((ISIZE-n)/IBUF))*IBUF))<0) n0=0;
  return(n+n0);
 }

int main(argc,argv)
 int argc;
 char **argv;
 {
  char bitval[8];

  putenv("TZ=GMT0");
  tzset();
  bytesold=MALLOC((ISIZE+1)*sizeof(*bytesold));
  memset(bytesold,0,(ISIZE+1)*sizeof(*bytesold));
  bytesfcm=MALLOC((ISIZE+1)*sizeof(*bytesfcm));
  memset(bytesfcm,0,(ISIZE+1)*sizeof(*bytesfcm));

  trace=1;

  GetCommNames(argc,argv);

# if !defined JUNIOR
#  if !defined MSDOS && !defined _WINDOWS
    if (ProgMsg)
#  endif
    {
     initcurses();
     cursor_off();
    }
# endif

  done=0;
  usedold=0;
  donefcm=0;
/* This is the amount of the fcm file that we have already processed as a
   previous hunk,  and of the old file that we have used. */

  memcpy(bitval,"00000000",8);
  for (i=0;i<=254;i++) {
   memcpy(bits[i].bits,bitval,8);
   ptr=7;
   doneadd=0;
   while (doneadd==0) {
    if (bitval[ptr]=='0') {
     bitval[ptr]='1';
     doneadd=1;
    }
    else {
     bitval[ptr]='0';
     ptr=ptr-1;
    }
   }
  }
  memcpy(bits[255].bits,bitval,8);

  dgf=NULL;

# if !defined JUNIOR
   if (Trace2file)
    if ((dgf=fopen(diagoutput,"w"))==NULL) {
     fprintf(stderr,"\n\rUnable to open file %s\n\r",diagoutput);
     EndOfPgr(1);
    }

   if (ProgMsg) {
    vidclrscr();
    vidgotoxy(1,2);
    /* color 14,4,1 */
    CPRINTF("%s",version);
    /* color 15,1,1 */
    refresh();
   }
# endif

  if (BriefMsg) {
   printf("\r%s\n\r",version);
   printf("\n\r");
   sprintf(prevperc,"%5.1f",0.0);
   printf("\rPercent done is: %s%%",prevperc);
  }

  buff=MALLOC(IBUF);

  if ((fpfcm=open(fcmfile,O_RDONLY|O_BINARY))<0) {
   fprintf(stderr,"\n\r**** ERROR - Diff file %s does not exist\n\r",fcmfile);
   EndOfPgr(1);
  }

  lengthfcm=lseek(fpfcm,0L,SEEK_END);

  lseek(fpfcm,0L,SEEK_SET);

  ICNT2=GetBytes2(0);

  realendfcm=ISIZE;
  endfcm=ISIZE2;
  if (lengthfcm<ISIZE) {
   endfcm=(int) lengthfcm;
   realendfcm=(int) lengthfcm;
  }

# if !defined JUNIOR
   if (ProgMsg) {
    vidgotoxy(1,11);
    CPRINTF("First hunk of diff file loaded - total length is  %ld bytes",lengthfcm);
    refresh();
   }
# endif

  fcmpointer=1;


# if defined SUMCHK
/*
#if defined JLv1_1
  0.  the value "JL" then the version number (currently hex 1)
#endif
  1.  a length count (one octet)for the next item.
#if defined JLv1_1
      (on decompression,  a file TEMP.TMP will be created in the current
      directory,  and then copied to the original destination path when
      decompression is complete,  unless overridden by a different target).
#else
  2.  the full path name of the file that is to be compressed
      (on decompression,  a file TEMP.TMP will be created in the current
      directory,  and then copied to the original destination path when
      decompression is complete,  unless overridden by a different target).
#endif
  3.  two octets of sum check for the whole of this file;  the sum check
      is the standard one of SIGMA(Ai) and SIGMA(iAi),  all MOD 255.
  4.  a length count for the next item.
  5.  the full path name of the reference file (this can be overridden
      on decompression)
#if defined JLv1_1
  6.  two octets of sum check for the first 10K of the reference file.
  7.  the value "JL"
#else
  6.  two octets of sum check for the first 1K of the reference file.
#endif
*/
#  if defined JLv1_1
    if ((bytesfcm[fcmpointer++]!='J') || (bytesfcm[fcmpointer++]!='L') ||
        (bytesfcm[fcmpointer]==0x00)) {
     fprintf(stderr,"\n\r%s is not a correctly formatted FCM file\n\r",fcmfile);
     EndOfPgr(1);
    }
    if (bytesfcm[fcmpointer++]!=0x01) {
     fprintf(stderr,"\n\r%s is a higher version than this version of JLUNPAK\n\r",fcmfile);
     EndOfPgr(1);
    }
#  endif
   octlen=bytesfcm[fcmpointer];
   fcmpointer=fcmpointer+octlen+1;
   sumcheckval1=bytesfcm[fcmpointer++];
   sumcheckval2=bytesfcm[fcmpointer++];
   octlen=bytesfcm[fcmpointer];
   fcmpointer=fcmpointer+octlen+1;
   oldsumcheckval1=bytesfcm[fcmpointer++];
   oldsumcheckval2=bytesfcm[fcmpointer++];
#  if defined JLv1_1
    if ((bytesfcm[fcmpointer++]!='J') || (bytesfcm[fcmpointer++]!='L')) {
     fprintf(stderr,"\n\r%s is not a correctly formatted FCM file\n\r",fcmfile);
     EndOfPgr(1);
    }
#  endif
# else
/*
  1.  'JL' signature
  2.  0x02 version nr
  3.  four octets with julian date of the file that is to be compressed
  4.  two octets with mode of the file
  5.  four octets of crc check for the whole of this file.
  6.  four octets that contain the size of the reference file.
  7.  four octets of crc check for the whole of the reference file.
  8.  the value "JL"
*/

   if ((bytesfcm[fcmpointer++]!='J') || (bytesfcm[fcmpointer++]!='L') ||
       (bytesfcm[fcmpointer++]!=0x02)) {
    fprintf(stderr,"\n\r**** ERROR - diff file %s contains invalid data\n\r",fcmfile);
    EndOfPgr(1);
   }

   filetime=(unsigned long) bytesfcm[fcmpointer++];
   filetime|=(unsigned long) bytesfcm[fcmpointer++]<<8;
   filetime|=(unsigned long) bytesfcm[fcmpointer++]<<16;
   filetime|=(unsigned long) bytesfcm[fcmpointer++]<<24;

   mode=(unsigned short) bytesfcm[fcmpointer++];
   mode|=(unsigned short) bytesfcm[fcmpointer++]<<8;

   crcval=(unsigned long) bytesfcm[fcmpointer++];
   crcval|=(unsigned long) bytesfcm[fcmpointer++]<<8;
   crcval|=(unsigned long) bytesfcm[fcmpointer++]<<16;
   crcval|=(unsigned long) bytesfcm[fcmpointer++]<<24;

   refsize=(unsigned long) bytesfcm[fcmpointer++];
   refsize|=(unsigned long) bytesfcm[fcmpointer++]<<8;
   refsize|=(unsigned long) bytesfcm[fcmpointer++]<<16;
   refsize|=(unsigned long) bytesfcm[fcmpointer++]<<24;

   oldcrcval=(unsigned long) bytesfcm[fcmpointer++];
   oldcrcval|=(unsigned long) bytesfcm[fcmpointer++]<<8;
   oldcrcval|=(unsigned long) bytesfcm[fcmpointer++]<<16;
   oldcrcval|=(unsigned long) bytesfcm[fcmpointer++]<<24;

   if ((bytesfcm[fcmpointer++]!='J') || (bytesfcm[fcmpointer++]!='L')) {
    fprintf(stderr,"\n\r**** ERROR - diff file %s contains invalid data\n\r",fcmfile);
    EndOfPgr(1);
   }
# endif

# if !defined JUNIOR
   if (ProgMsg) {
    vidgotoxy(1,11);
    CPRINTF("%79s\rDecompressing %s using %s as a reference file","",fcmfile,reffile);
    refresh();
   }
# endif

  if ((fpold=open(reffile,O_RDONLY|O_BINARY))<0) {
   fprintf(stderr,"\n\r**** ERROR - Reference file %s does not exist\n\r",reffile);
   EndOfPgr(1);
  }
  lengthold=lseek(fpold,0L,SEEK_END);

# if defined SUMCHK
   lseek(fpold,0L,SEEK_SET);
   oldsumcheck1=0;
   oldsumcheck2=0;

   checked=0;
   while ((checked<Nchecked) && ((n0=read(fpold,(char *) buff,IBUF))>0)) {
    checked=checked+1;
    for (i=0;i<n0;i++) {
     octval=buff[i];
     oldsumcheck1=(oldsumcheck1+octval)%255;
     oldsumcheck2=(oldsumcheck2+oldsumcheck1)%255;
    }
   }
# else
   if ((unsigned long) lengthold!=refsize) {
    fprintf(stderr,"\n\r**** ERROR - Reference file %s has incorrect size\n\r",reffile);
    EndOfPgr(1);
   }
   updcrc(NULL,0,&oldcrc);
# endif

  lseek(fpold,0L,SEEK_SET);

# if defined SUMCHK
   if ((oldsumcheckval1!=oldsumcheck1) || (oldsumcheckval2!=oldsumcheck2)) {
    fprintf(stderr,"\n\r**** ERROR - Sumcheck of reference file differs from original\n\r");
    EndOfPgr(1);
   }
# endif

  ICNT1=GetBytes1(0);

  endold=ISIZE;
  if (lengthold<ISIZE) endold=(int) lengthold;

# if !defined JUNIOR
   if (ProgMsg) {
    vidgotoxy(1,10);
    CPRINTF("First hunk of reference file loaded - total length is  %ld bytes",lengthold);
    refresh();
   }
# endif

/* Now we initialise all variables,  ready to start the first hunk
   decompression */

/*
 The receivers state is set up with ptroffset=0,  diffa=0,  and
 diffb=0 and donefcm&=0 and usedold&=0.
 These values are retained unless explicitly
 changed.  The difference is new - old
*/

  ptr=0;
  memset(gdiff,0,sizeof(gdiff));
  ptroffset=0;
  cnt=0;
  lastperc=0;
  outputcnt=0;

  obuff=MALLOC(OBUF);
  n=0;
  reallyfinished=0;

  if ((fp=open(newfile,O_RDWR|O_TRUNC|O_CREAT|O_BINARY,CREATEFLAGS))<0) {
   fprintf(stderr,"\n\rUnable to open file %s\n\r",newfile);
   EndOfPgr(1);
  }

# if !defined SUMCHK
   updcrc(NULL,0,&crc);
# endif

  do {
   /* This is the outer loop,  LOOP UNTIL finished,  for each hunk. */

/* We take each octet of fcmbytes in turn. */

   while (fcmpointer<=endfcm) {
#   if !defined JUNIOR
     if (ProgMsg) {
      realperc=((((double) (fcmpointer-1))+((double) donefcm))*100.0)/(double) lengthfcm;
      vidgotoxy(1,20);
      CPRINTF("Percent done is: %5.1f%%     ",realperc);
      refresh();
     }
#   endif
    if (BriefMsg) {
     realperc=((((double) (fcmpointer-1))+((double) donefcm))*100.0)/(double) lengthfcm;
     sprintf(perc,"%5.1f",realperc);
     if (strcmp(perc,prevperc)) {
      strcpy(prevperc,perc);
      printf("\rPercent done is: %s%%",perc);
     }
    }

    code=bytesfcm[fcmpointer];

/* On decompression,  we branch on bit 1 equals 1 or 0,  and if bit 1 is 1,
   then we branch on 10 or 11. */

    codecase=0;
    if (code>=128) {
     if ((code/64)==2) {

/* codecase=1-no match
  For 10,  we pick up nnnnnn,  and copy
  ISEG*nnnnnn octetcs from the fcm to the target.
*/

      codecase=1; /* Bits are 10 - no match for count segments */
      count=code%64;
      if (count==0) count=64;
     }
     else {
/*
 codecase=2 - total match (type A)
 This is the branch from first bit 1,  first two 11.
 We copy ISEG*nnnnnn octets from the old file,  starting at cnt +
 ptroffset+1.  nnnnnn is in count.
*/
      codecase=2; /* Bits are 11 - total match for count segments */
      count=code%64;
      if (count==0) count=64;
     }
    }
    else {
/*
 codecase=3-pointer change
 If there is a pointer change,  we need to signal it in the output.
 We have four cases for the value of the ptr change:
              positive and less than (or equals) 256
              negative and less than (or equals) 256
              positive and over 256
              negative and over 256
 We use 00000000,  00000001, 00010000, and 00010001 for these four cases.
 In the first two cases,  we follow with a single octet,  and in the last
 two with two octets.  In the case of the single octet,  zero means 256.
 On decompression,  we are in the first bit zero case,  and branch first on
 the bottom four bits,  taking the 0 and 1 cases here.  For zero,  we are
 collecting a positive value, and for 1 a negative.  Next we branch on the
 value of nnn in 0nnn000x.  For 0 we have a single octet following and
 a value to be added (after negation if necessary) to ptroffset.  For 1
 we have a two octet value (most significant first).
      Bit 1 is zero - further analysis needed
*/
     subcode=code/16; /* pick up nnn */
     code1=code%16;
     if ((code1==0) || (code1==1)) {
/*
 codecase=4-diff change
 If a change of a diff is needed,  we
 have the following cases for the diff:
              positive and less than 256
              negative and less than 256
 We use 00100000 and 00100001 for these cases for diffa,  00110000 and
 00110001 for these cases for diffb,  01000000 and 01000001 for diffc,
 and 0101000 and 01010001 for diffd,  followed by a single byte which gives
 the fcm diff value.
 On decompression, this is the nnn=2 (diffa), 3 (diffb), 4 (diffc) and
 5 (diffd) cases described under pointer above.

 This completes the use of the 0mmm0000 and 0mmm0001 values
 except for 110 which is used in termination below,  and 111 which is spare.
 Remaining codes are
 0mmmxxxx where xxxx is above 0001.
*/
      negate=code1; /* 1 if we are to negate */
      switch (subcode) {
       case 0:
        octets=1;
        codecase=3; /* Pointer change */
        break;
       case 1:
        octets=2;
        codecase=3; /* Pointer change */
        break;
       case 2:
	codecase=4; /* diffa change */
	diffindx=1;
        break;
       case 3:
        codecase=4; /* diffb change */
        diffindx=2;
        break;
       case 4:
        codecase=4; /* diffc change */
        diffindx=3;
        break;
       case 5:
        codecase=4; /* diffd change */
        diffindx=4;
        break;
       case 6:
/*
 codecase=5
 Where we have discarded some old file and refilled the buffers,  we
 signal this
 in the output by putting out a single octet of 01100000 followed by
 two octets giving the amount of the move.
 On decompression,  this is a signal to move the new file by the full
 10K,  and to move the old file by the specified amount.

 codecase=6
 Finally,  we have to cope with the residual set of up to 15 octets at the
 end of the file.   We simply output 01100001,  then a single octet saying
 how many follow,  then the octets.  If there are none,  we still output
 the single octet and the null count.  On decompression,  we copy octets
 across.
*/
	if (code1==0)
	 codecase=5; /* Move the reference file down */
	else
	 codecase=6; /* Copy the residual octets from the fcm file */
	break;
       case 7:
	fprintf(stderr,"\n\r**** ERROR - FCM format error - Value 6 or 7 with code1=0 or 1\n\r");
	EndOfPgr(1); /* Do nothing - value 7 is spare. */
	break;
      }
     }
     else {
/* Now we have cases of code1 above 0 and 1, with the subcode holding
   a count. */

      count=subcode;
      if (count==0) count=8;
      switch (code1) {
/*
 codecase=7
 For a type B match,  we determine whether to use diffa,  b, c,  or d (based
 on this segment alone,  and possibly with a diff change).  We then merge in
 up to 8 segments (nnn=000 means 8) with the same pointer and diff value
 (after juggling diffs if necessary).  The coding is 0nnn0010 for use of diffa
 0nnn0011 for use of diffb,  0nnn0100 for use of diffc,  and 0nnn0101 for use of
 diffd.  nnn is the number of segments merged in.  We then follow with a
 string of bits,  one per byte in each of the segments,  where 0 means no
 addition, and 1 means add in the selected diff.   Bits up to the next octet
 boundary are ignored.
 On decompression,  we use nnn to determine the number of octets to be
 produced (16*nnn),  and then take as many octets as necessary to give
 us the additions of diffa,  b etc.  We start the old at cnt+ptroffset+1
 and we set new to old+diff. (Diff was defined as new - old)
*/
       case 2:
        codecase=7; /* Type B */
        diffindx=1; /* use diffa */
        break;
       case 3:
	codecase=7;
	diffindx=2; /* use diffb */
	break;
       case 4:
	codecase=7;
	diffindx=3; /* use diffc */
	break;
       case 5:
        codecase=7;
        diffindx=4; /* use diffd */
        break;
/*
 codecase=8
 For a type C match,  we have six possible diff selections to use, coded as
 follows (again,  merging in up to 8 possible segments):
            diffa and diffb    0nnn0110
            diffa and diffc    0nnn0111
            diffa and diffd    0nnn1000
            diffb and diffc    0nnn1001
            diffb and diffd    0nnn1010
            diffc and diffd    0nnn1011

 We then follow with a string of bits,  one per byte in each of the segments,
 where 0 means no addition,  and 10 means the first mentioned diff is added in,
 and 11 means the second mentionned diff is added in.
 On decompression,  this is values 6 to 11 of the bottom four octets. We
 proceed as for case B, except that we need to use two diffs,  diff1 and diff2
 taken from diffa to diffd according to the case being considered.
*/
       case 6:
        codecase=8;
        diffindx1=1;
        diffindx2=2;
        break;
       case 7:
	codecase=8;
	diffindx1=1;
	diffindx2=3;
	break;
       case 8:
	codecase=8;
	diffindx1=1;
	diffindx2=4;
	break;
       case 9:
	codecase=8;
	diffindx1=2;
	diffindx2=3;
	break;
       case 10:
	codecase=8;
	diffindx1=2;
	diffindx2=4;
	break;
       case 11:
        codecase=8;
        diffindx1=3;
	diffindx2=4;
	break;
/*
 codecases 9 and 10
 For a type D match,  we encode the segments
 as 0nnn1100 (for up to 8 segments) where we have four differs,  and
 0nnn1101 where diffa is omitted, 0nnn1101 where diffb is omitted,  0nnn1110
 where diffc is omitted,  and 0nnn1111 where diffd is omitted.
 This is followed by a bitstring for each
 octet in each of the segments,  where we have 0 if no diff is to
 be added in,  then,  for the three differs in use,
 100 if the first is to be added in, 101 for the second,  and 11 for the third.
 For four differs,  we have
 100 if diffa is to be added in,  101 for diffb,  110 for diffc,
 111 for diffd.
 On decompression,  this is again similar to CASE C,  except that we have
 three or four differs depending on the value 12 (four) or 13 to 16 (three)
 of the case.  The value of the case says which differ is omitted.
*/
       case 12:
        codecase=9;
        diffindx1=1;
        diffindx2=2;
        diffindx3=3;
	diffindx4=4;
	break;
       case 13:
	codecase=10;
	diffindx1=2;
	diffindx2=3;
	diffindx3=4;
	break;
       case 14:
	codecase=10;
	diffindx1=1;
	diffindx2=3;
	diffindx3=4;
	break;
       case 15:
	codecase=10;
	diffindx1=1;
	diffindx2=2;
	diffindx3=4;
	break;
/* CASE 16 cannot occur because of lack of code space */
      }
     }
    }

#   if !defined JUNIOR
     if (Trace2file) {
      fprintf(dgf,"Attempting codecase  %d Ptroffset  %d Cnt  %d\n",codecase,ptroffset,cnt);
      fprintf(dgf,"           Differences:  %d  %d  %d  %d\n",gdiff[1],gdiff[2],gdiff[3],gdiff[4]);
     }
#   endif

    switch (codecase) {
     case 1: /* Copy ISEG*count octets from the fcm to the target. */
      for (ijl=1;ijl<=ISEG*count;ijl++)
       OutputSub(bytesfcm[fcmpointer+ijl]);
      fcmpointer=fcmpointer+1+ISEG*count;
      cnt=cnt+ISEG*count;
      break;
     case 2: /* Copy ISEG*count octets from the old file,  starting at
                cnt+ptroffset+1. */
      for (ijl=1;ijl<=ISEG*count;ijl++)
       OutputSub(bytesold[cnt+ptroffset+ijl]);
      fcmpointer=fcmpointer+1;
      cnt=cnt+ISEG*count;
      break;
     case 3: /* Add to ptroffset,  a one octet value (octets=1) or a two
                octet value (octets =2),  or subtract if negate=1 */
      octval=bytesfcm[fcmpointer+1];
      if (octets==2) octval=octval*256+bytesfcm[fcmpointer+2];
      if ((octets==1) && (octval==0)) octval=256;
      if (negate==1) octval=-octval;
      ptroffset=ptroffset+octval;
      fcmpointer=fcmpointer+octets+1;
      break;
     case 4: /* Set gdiff(diffindx) to the one octet value which follows,
                negated if negate is one. */
      octval=bytesfcm[fcmpointer+1];
      if (negate==1) octval=-octval;
      gdiff[diffindx]=octval;
      fcmpointer=fcmpointer+2;
      break;
     case 5: /* The next two octets code up the move down of old./ */
      if (BriefMsg) {
       realperc=(((double) (fcmpointer-1)+(double) donefcm)*100.0)/(double) lengthfcm;
       sprintf(perc,"%5.1f",realperc);
       if (strcmp(perc,prevperc)) {
        strcpy(prevperc,perc);
        printf("\rPercent done is: %s%%",perc);
       }
      }
/* Now we have to move the old and adjust pointers */
      Move=bytesfcm[fcmpointer+1]*256+bytesfcm[fcmpointer+2];
      fcmpointer=fcmpointer+3;
/* move oldarray down by move and adjust cnt */
      cnt=cnt-Move;
      usedold=usedold+Move;
      endold=endold-Move;
      for (i=1;i<=endold;i++)
       bytesold[i]=bytesold[i+Move];
#     if !defined JUNIOR
       if (Trace2file)
        fprintf(dgf,"Moving old file by %d\n",Move);
#     endif
/* Now read in as much as possible of the old file to fill the buffer. */

      ICNT1=GetBytes1(endold);

      endold=ISIZE;
      if (lengthold-usedold<ISIZE) endold=(int) (lengthold-usedold);

#     if !defined JUNIOR
       if (ProgMsg) {
        vidgotoxy(1,10);
        CPRINTF("%79s\rNext hunk of old file loaded - proceeding with decompression","");
        vidgotoxy(1,11);
        CPRINTF("%80s","");
        refresh();
       }
#     endif
      break;
     case 6: /* Copy a number of octets given by the next octet from the
		fcm file to the new file.  This is the last up to 15 octets,  and
		we are finished.  The fcm file should be exhausted. */
      reallyfinished=1;
      copybytes=bytesfcm[fcmpointer+1];
      for (ijl=2;ijl<=copybytes+1;ijl++)
       OutputSub(bytesfcm[fcmpointer+ijl]);
      fcmpointer=fcmpointer+2+copybytes;
      cnt=cnt+copybytes;
      break;
     case 7: /* Produce count*ISEG octets of new file by taking the old
		and adding gdiff(diffindx) if the bit in the following octets is one. */
      bitstringptr=0;
      fcmpointer=fcmpointer+1;
      numocts=count*ISEG;
      while (numocts!=0) {
       if (GetBit()==0)
	OutputSub(bytesold[cnt+ptroffset+1]);
       else
	OutputSub(bytesold[cnt+ptroffset+1]+gdiff[diffindx]);
       numocts=numocts-1;
       cnt=cnt+1;
      }
      break;
     case 8: /* Produce count*ISEG octets of new file by taking the old
                and adding gdiff(diffindx1) for 10, and gdiff(diffindx2) for 11, and
		nothing for 0 */
      bitstringptr=0;
      fcmpointer=fcmpointer+1;
      numocts=count*ISEG;
      while (numocts!=0) {
       if (GetBit()==0)
        OutputSub(bytesold[cnt+ptroffset+1]);
       else
	if (GetBit()==0)
         OutputSub(bytesold[cnt+ptroffset+1]+gdiff[diffindx1]);
        else
         OutputSub(bytesold[cnt+ptroffset+1]+gdiff[diffindx2]);
       numocts=numocts-1;
       cnt=cnt+1;
      }
      break;
     case 9: /* Produce count*ISEG octets of new file by taking the old
                and adding nothing for 0,  gdiff(1) for 100, gdiff(2) for 101,  gdiff(3)
                for 110,  and gdiff(4) for 111. */
      bitstringptr=0;
      fcmpointer=fcmpointer+1;
      numocts=count*ISEG;
      while (numocts!=0) {
       if (GetBit()==0)
	OutputSub(bytesold[cnt+ptroffset+1]);
       else
	if (GetBit()==0)
	 if (GetBit()==0)
          OutputSub(bytesold[cnt+ptroffset+1]+gdiff[diffindx1]);
         else
          OutputSub(bytesold[cnt+ptroffset+1]+gdiff[diffindx2]);
        else
	 if (GetBit()==0)
          OutputSub(bytesold[cnt+ptroffset+1]+gdiff[diffindx3]);
         else
          OutputSub(bytesold[cnt+ptroffset+1]+gdiff[diffindx4]);
       numocts=numocts-1;
       cnt=cnt+1;
      }
      break;
     case 10: /* Produce count*ISEG octets of new file by taking the old
                 and adding nothing for 0, gdiff(diffindx1) for 100, and gdiff(diffindx2)
                 for 101, gdiff(diffindx3) for 11. */
      bitstringptr=0;
      fcmpointer=fcmpointer+1;
      numocts=count*ISEG;
      while (numocts!=0) {
       if (GetBit()==0)
        OutputSub(bytesold[cnt+ptroffset+1]);
       else
	if (GetBit()==0)
	 if (GetBit()==0)
          OutputSub(bytesold[cnt+ptroffset+1]+gdiff[diffindx1]);
         else
          OutputSub(bytesold[cnt+ptroffset+1]+gdiff[diffindx2]);
        else
         OutputSub(bytesold[cnt+ptroffset+1]+gdiff[diffindx3]);
       numocts=numocts-1;
       cnt=cnt+1;
      }
      break;
     default:
      fprintf(stderr,"\n\r**** ERROR - FCM format error - Bad codecase\n\r");
      EndOfPgr(1);
      break;
    }
   }

#  if !defined JUNIOR
    if (ProgMsg) {
     realperc=((((double) (fcmpointer-1))+((double) donefcm))*100.0)/(double) lengthfcm;
     vidgotoxy(1,20);
     CPRINTF("Percent done is: %5.1f%%     ",realperc);
     refresh();
    }
#  endif

   if (BriefMsg) {
    realperc=((((double) (fcmpointer-1))+(double) donefcm)*100.0)/(double) lengthfcm;
    sprintf(perc,"%5.1f",realperc);
    if (strcmp(perc,prevperc)) {
     strcpy(prevperc,perc);
     printf("\rPercent done is: %s%%",perc);
    }
   }

/* Now loop to do another hunk if necessary */
   finished=0;
   if (lengthfcm<=endfcm+donefcm) {
    finished=1;
    if (BriefMsg)
     printf("\rPercent done is: %5.1f%%",100.0);
   }
   else {
/* Prepare for next hunk */

    fcmpointer=fcmpointer-ISIZE3;
    donefcm=donefcm+ISIZE3;
/* move fcm array down by ISIZE3 */

    realendfcm=realendfcm-ISIZE3;
    for (ijl=1;ijl<=realendfcm;ijl++)
     bytesfcm[ijl]=bytesfcm[ijl+ISIZE3];

/* Now read in as much as possible of the fcm file to fill the buffer. */

    ICNT2=GetBytes2(realendfcm);

    realendfcm=ISIZE;
    endfcm=ISIZE2;
    if (lengthfcm-donefcm<=ISIZE) {
     endfcm=(int) (lengthfcm-donefcm);
     realendfcm=endfcm;
    }
#   if !defined JUNIOR
     if (ProgMsg) {
      vidgotoxy(1,10);
      CPRINTF("%79s\rNext hunk of diff file loaded - proceeding with decompression","");
      vidgotoxy(1,11);
      CPRINTF("%80s","");
      refresh();
     }
#   endif

/* This ends the preparation for the next hunk. */
   }
  } while (!finished);

  if (reallyfinished!=1) {
   fprintf(stderr,"\n\r**** ERROR - FCM format error - Ran out of FCM file before finished\n\r");
   EndOfPgr(1);
  }

# if defined SUMCHK
   if ((sumcheckval1!=sumcheck1) || (sumcheckval2!=sumcheck2)) {
    fprintf(stderr,"\n\r**** ERROR - Sumcheck of reconstituted file differs from original\n\r");
    EndOfPgr(1);
   }
# else
   if (oldcrcval!=updcrc(obuff,0,&oldcrc)) {
    fprintf(stderr,"\n\r**** ERROR - crc of reference file differs from original\n\r");
    EndOfPgr(1);
   }

   if (crcval!=updcrc(obuff,0,&crc)) {
    fprintf(stderr,"\n\r**** ERROR - crc of reconstituted file differs from original\n\r");
    EndOfPgr(1);
   }
# endif

# if !defined JUNIOR
   if (ProgMsg) {
    vidgotoxy(1,13);
    CPRINTF("%79s\rDecompression complete.  Number of octets output is %ld","",outputcnt);
    vidgotoxy(1,24);
    refresh();
   }
# endif

  if (BriefMsg)
   printf("\n\rDecompression complete.\n\r");

  EndOfPgr(0);
  return(0);
 }